// *****************************************************************************
//
// source:    AC_RICH_init.C
//
// type:      source code
//
// created:   03 Nov 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    AC_RICH_init()
//
// called by: AC_init()
//
// hints:     see $HBROOT/ARTE/dev/include/dq/DQ.h for COMP_XYZ and LVL_ABC
//
// changes:
// 03 Nov 1999 (AG) further developments
// 19 Nov 1999 (AG) cna -> ac (alca)
// 22 Nov 1999 (AG) includes in alca
// 02 Feb 2000 (DD) beta=1 histo, 
//                  rings/event histo,
//                  reco beta=1 histo 
// 03 Feb 2000 (AG) fixed function name
//
// *****************************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// includes
#include "dq/DQ.h"
#include "dq/DQ_RICH.h"

#include "arte/arte.hh"

#include "rhp.h"
#include "pub.h"

int AC_RICH_init()
{

 // show up
  cout << "AC_RICH_init()" << endl;

/////////////////////  Declare RICH histograms /////////////////////////////
  rhp_hbook1(AC_ID(COMP_RICH, LVL_REC, 200),"RICH: Number of RICH rings per event",50,-0.5,49.5);
  rhp_hbook2(AC_ID(COMP_RICH, LVL_REC, 201),"RICH: track directions",50,-0.3,0.3,50,-0.3,0.3);
  rhp_hbook1(AC_ID(COMP_RICH, LVL_REC, 202),            "RICH: Cherenkov angle",400,0.02,0.06);
  rhp_hbook1(AC_ID(COMP_RICH, LVL_REC, 203),"RICH:      Beta=1 Cherenkov angle",400,0.02,0.06);
  rhp_hbook1(AC_ID(COMP_RICH, LVL_REC, 204),"RICH: Reco Beta=1 Cherenkov angle",400,0.02,0.06);


  return 0; // return error code (0 = okay)
}
