// ********************************************************************
//
//  Routine:      acGlobalToLocal.C
//  Author:       T. Oest
//
//  Description:  transformation from global to local coordinates
//                input  rGlobal[5]  x,y,z,tx,ty
//                output rLocal[5]   x,y,z,tx,ty
//               
//
//  Modification:
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>

#include "arte/arte.hh"

//****************************************************************
// function
//****************************************************************

int acGlobalToLocal(float * rLocal, float * rGlobal, int cmp){

 int flag = -1;

//----------------------------------------------------------------
// loop over ACGA table to get global alignment constants
//----------------------------------------------------------------
    for( ArteTable<ACGA>::iterator acga = ArteTable<ACGA>::begin();
         acga != ArteTable<ACGA>::end(); ++acga ) {

      if ((*acga)->cmp == cmp){

    float z0, dx, dy, dtx, dty, cphi, sphi;
    float dz, x, y, tx, ty;

    z0   = (*acga)->z;
    dx   = (*acga)->dx;
    dy   = (*acga)->dy;
    dtx  = (*acga)->dtx;
    dty  = (*acga)->dty;
    cphi = (*acga)->rot[0];
    sphi = (*acga)->rot[3];


    dz = rGlobal[2] - z0;
    x  = rGlobal[0];
    y  = rGlobal[1];
    tx = rGlobal[3];
    ty = rGlobal[4];

    x  = x - dx - dz * dtx;
    y  = y - dy - dz * dty;
    tx = tx - dtx;
    ty = ty - dty;


    rLocal[0] =   x * cphi +  y * sphi;
    rLocal[1] =  -x * sphi +  y * cphi;
    rLocal[2] = rGlobal[2];
    rLocal[3] =  tx * cphi + ty * sphi;
    rLocal[4] = -tx * sphi + ty * cphi;
 
      };

    flag = 0;
      };


  if (flag != 0){
     rLocal[0] = rGlobal[0];
     rLocal[1] = rGlobal[1];
     rLocal[2] = rGlobal[2];
     rLocal[3] = rGlobal[3];
     rLocal[4] = rGlobal[4];
  };

//----------------------------------------------------------------
// 
//----------------------------------------------------------------

 return flag;

};



