/*
//     
//: MEPack.h
//
// C interface definition to the ARTE MESSAGE PACKAGE
//
//
// Author: Mauro Villa
// ECAL group
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/5/97
// Last Update ........
//
*/

#ifndef MEPACK_H_
#define MEPACK_H_

/* Write c78[] on all printers */
void me78ap_();

/* Error Message; count for final statistics */
void me78ec_(int* ID);

/* Write error meessage on all printer units;
        Batch: stop program;
        Interactive: stop or continue       */
void me78er_();

/* List, count and handle an error  */
void me78mc_(int* ID, int* NP, int *NF);

/* Count and print an error  */
void me78pc_(int* ID, int* NP);

/* Print text c78[] on all printers declared by CTPL  */
void me78sp_(char* CTPL, int len);

/* Print warning */
void me78wa_();

/* Warning, count number of occurencies */
void me78wc_(int* ID);

/* Write Message on all printers */
void meallp_(char* CTXT, int len);

/* error message; count for final statistics */
void meerrc_(int *ID, char* TEXT, int len);

/* Write error message on all printer units.
        Batch: stop program.
        Interactive: stop or continue.  */
void meerro_(char* CTXT, int len);

/*  list, count, handle an error */
void memesc_(int* ID, int* NP, int * NF, char* TEXT, int len);

/* count and print a message */
void mepric_(int* ID, int* NP, char* TEXT, int len);

/* print text CTXT on all printers declared by CTPL */
void meselp_(char* TEXT, char* CTPL, int lenTEXT, int lenCTPL);

/* warning; count number of occurrencies */
void mewarc_(int *ID, char* TEXT, int len);

/* print warning */
void mewarn_(char* TEXT, int len);

#endif /* MEPACK_H_ */
