#ifndef _RSEG_cmp_h_
#define _RSEG_cmp_h_

/* Least significant bits indicate LOGICAL function of detector part */
/* Most significant bits  indicate hardware type of detector part    */
/* Example: segments with SI08 hits have hardware bit Rsegc::sil     */
/*                                    and logical bit Rsegc::magt set*/

#define RSEGC_VXD     (         1l) /* Vertex Detector */
#define RSEGC_PATT    (         2l) /* Pattern Tracker*/
#define RSEGC_MAGT    (         4l) /* Magnet Tracker*/
#define RSEGC_MUON    (         8l) /* Muon Detector*/
#define RSEGC_ECAL    (        16l) /* Ecal*/
#define RSEGC_TAR     (        32l) /* Target Constraint*/

#define RSEGC_TRIT    (        64l) /* Trigger Tracker, betw RICH and ECAL */
#define RSEGC_BIT7    (       128l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT8    (       256l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT9    (       512l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT10   (      1024l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT11   (      2048l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT12   (      4096l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT13   (      8192l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT14   (     16384l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT15   (     32768l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT16   (     65536l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT17   (    131072l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT18   (    262144l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT19   (    524288l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT20   (   1048576l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT21   (   2097152l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT22   (   4194304l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT23   (   8388608l) /* not assigned yet (first bit is bit0)*/
#define RSEGC_BIT24   (  16777216l) /* not assigned yet (first bit is bit0)*/

#define RSEGC_TRD     (  33554432l) /* TRD straw device type*/
#define RSEGC_RICH    (  67108864l) /* Cherenkov Counter device type*/
#define RSEGC_PTC     ( 134217728l) /* HiPT Chamber device type*/
#define RSEGC_MSG     ( 268435456l) /* MSGC device type*/ 
#define RSEGC_WCH     ( 536870912l) /* honeycomb wire chamber device type*/
#define RSEGC_SIL     (1073741824l) /* silicon strip device type*/
#define RSEGC_BITSIGN (-2147483648l) /* Kill bit, set if segment is deleted */
#endif
































