*-- Author :    Hartwig Albrecht   29/03/95

      SUBROUTINE MMRDAT (LUN, IHD, ILN)

************************************************************************
*
* Description: Read data of next Zebra record
*
* Called from: MMREAD, MMRMIX
*
* External references: FZIN
*
* Argument in/out description
*   LUN    in     logical unit
*   ILN    out    > 0: link to the actual bank
*                 < 0: end of data
*                 0: skip event
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "auto/MEMO.fi"
#include "auto/MEIO.fi"
#include "arte/ZQUEST.fi"

      INTEGER LUN, IHD, ILN, DUMMY, I, J, K, IEVHD, LOCF, NLAST, ICOL
      CHARACTER CNAME*80

#include "arte/Arte.ff"
#include "auto/MEMO.ff"
#include "auto/MEIO.ff"

      IEVHD = LOCF(JEVHD) - LARLN1
      NLAST = 0
      IF (JLINK(ILN) .EQ. 0)  GO TO 10

C bank exists: drop all tables before reading new data (mmread: IHD = 0)
C              drop all tables except EVHD in case of event mixing
C              (mmrmix: IHD > 0)

      IF (IQ(JLINK(ILN)+2) .GT. 0 .AND. IHD .NE. IEVHD)  THEN
        C78 = 'MMRDAT: existing table'
        CALL CHHTOC (IQ(HQMEMO_NAME(1,ILN)), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78BC ('overwritten')
        CALL ME78PC (7534, 30)
        CALL MMDROP (JLINK(ILN))
      END IF
      NLAST = N_U(JLINK(ILN))

C read data: GPACK

 10   IF (IMEIO_PACK(IMEIO_CURRENT(LUN)) .EQ. 2) THEN

        CALL GARTRDAT (LUN, ILN, ICOL, IQUEST(1))
        IF (IQUEST(1) .LT. 0)  GO TO 80
        IF (IQUEST(1) .EQ. 5)  THEN
          ILN = -1
          GO TO 90
        END IF
        IF (IQUEST(1) .EQ. 100)  THEN
          ILN = 0
          GO TO 90
        END IF
        GO TO 20
      END IF

C or Zebra: temporary table JZEBRA unavoidable (CM and MEMO_OCOL)!

      IF (JZEBRA .NE. 0)  CALL MZDROP (IMEMO_DIV(ILN), JZEBRA, ' ')
      JZEBRA = 0
      CALL FZIN (LUN, IMEMO_DIV(ILN), JZEBRA, 1, 'A', DUMMY, DUMMY)
      IF (IQUEST(1) .LT. 0)  GO TO 80

C check that no data will be overwritten if too many columns on input

      ICOL = N_C(JZEBRA)
      IF (ICOL .NE. IMEMO_OCOL(ILN))  THEN
        C78 = 'MMRDAT: table'
        CALL CHHTOC (IQ(HQMEMO_NAME(1,ILN)), CNAME)
        CALL CH78BC (CNAME)
        CALL CH78AC (': inconsistent # of columns. expected:')
        CALL CH78BI (IMEMO_OCOL(ILN))
        CALL CH78AC ('; on input:')
        CALL CH78BI (ICOL)
        CALL ME78MC (786459, 10, ILARGEST)
      END IF

C book and fill final table; be aware of event mixing (NLAST)

      CALL MMBOOK (JLINK(ILN), N_U(JZEBRA))

      IF (ICOL .EQ. IMEMO_COL(ILN))  THEN

C avoid nested loops if possible

        DO I = 1, N_U(JZEBRA) * ICOL
          IQ((JLINK(ILN)+NLAST*ICOL)+I+2) = IQ(JZEBRA+I+2)
        END DO

      ELSE

        DO J = 0, N_U(JZEBRA) - 1
          DO I = 1, MIN (ICOL, IMEMO_COL(ILN))
            IQ((JLINK(ILN)+(NLAST+J)*IMEMO_COL(ILN))+I+2) =
     +      IQ(JZEBRA+J*ICOL+I+2)
          END DO
        END DO
        IQ(JLINK(ILN)+1) = IMEMO_COL(ILN)

      END IF

 20   IQ(IQMEMO_NIN(ILN)) = IQ(IQMEMO_NIN(ILN)) + 1
      GO TO 90

C read error

 80   C78 = 'MMRDAT: read error. IQUEST(1) ='
      CALL CH78BI (IQUEST(1))
      CALL ME78MC (46586, ILARGEST, 10)
      CALL USRERR (LUN)
      GO TO 10

 90   END

************************************************************************
* End of MMRDAT
************************************************************************
