 
// *****************************************************************************
//
// source:    utcarg.C
//
// symbol:    void utcarg();
//
// externals: void utfarg_();
//            int  faLine();
//
// created:   27 Oct 1995
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// purpose:   prepare and pass shell arguments to Fortran routine utfarg_
//
// hints:     Fortran expects spaces as filling of character variables
//
// changes:
// 21 Aug 1998
// 23 Feb 2000 (AG) introduce ArteVersion.h and fill it into arteflag_.artevers
//
// *****************************************************************************
 
// standard includes
#include <iostream.h>
#include <stdio.h>
#include <string.h>

// Arte includes
#include "arte/ArteVersion.h"
#include "arte/ArteFlag.h"

// C prototypes
extern "C" {
void utcarg_();
void utfarg_( int *i, char *strg );
}

// C++ prototype
int faLine();

// externals
extern int  nArg;
extern char **vArg;

//
// program code
// 
void
utcarg_()
{
  // Arte version
  arteflag_.artevers = ARTEVERSION;

  // FARM flag
  arteflag_.inoutfarm = faLine();
  
  // locals
  char *strg = new char[120];
  
  // prepare argument string
  // note that vArg[i] does not necessarily point
  // to a full-word boundary (H.A.)
  for( int i=0; i<nArg; i++ ){
    strg  = strncpy( strg, vArg[i], 120 );
    utfarg_( &i, strg  );
  }
}
