//                              -*- Mode: C++ -*-
//: CmdCareCalib.hh
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 12/6/97
// Last Update ........
//

#ifndef CMDCARECALIB_HH_
#define CMDCARECALIB_HH_

#include "care/CmdBase.hh" 
#include "care/ECALtypes.hh"
/**
class  CmdCareCalib.
  Class to deal with the care/calib kuip command.

*/

class CmdCareCalib : public CmdBase {
public:
  /// Constructors
  CmdCareCalib();
  /// Destructor
  virtual ~CmdCareCalib();
  
  //-- Behavioural operations
  ///   Reset stored data to default values
  virtual void defValues();
  //--
  ///   Execute stored command
  virtual void execute();
# ifdef USEKUIP
  //--
  ///   Read a command from external
  virtual void read();
# endif
  //--
  ///   Dump internal data
  virtual void dump();

private:
  ///////////////////// Data Part /////////////////////////////////
  //--
  Energy_t  inner,middle,outer;
};

#endif  //   CMDCARECALIB_HH_
