
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Filling of histograms
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 05 Nov 1999 (AG) improve histogramming
// 06 Dec 1999 (CP) weight occupancies by radius
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_ECAL.h"

#include <CLHEP/Hist/HBookHistogram.h>


  int r_trig = 0;
  int p_trig = 0; 
  int n_mon  = 0; 

  double E_tot_in = 0;

//
// function code
//
int
DQ_ECAL_hit_evnt(){

  double E_sum_in  = 0;
  double E_sum_mid = 0;
  double E_sum_all = 0;

  double TotalHITCEnergy=0;
 
  double ThisEt,EmaxMid,EmaxInn;
  double XMidEtMax=0;
  double YMidEtMax=0;
  double XInnEtMax=0;
  double YInnEtMax=0;
  double EtMaxMid=0;
  double EtMaxInn=0;

  //int trigflag=100*faDDAQFCS_tcode();

  // tcode
  int tcode = faDDAQFCS_tcode();
  int trigflag = 0;
  if( tcode > 0 ) trigflag = 900; // fill histos for tcode =0 and #0

  // tcode == 9
  if (trigflag == 900) r_trig += 1;
  else p_trig += 1;

  //    
  // loop over all hitc to fill histogram
  //
  for( ArteTableIterator<HITC> hitc1; hitc1.valid(); hitc1.next() ){
    ArtePointer<GCCE> gcce = hitc1->gcce;
    ArtePointer<ECHF> echf(gcce.index());
    ArtePointer<ECHS> echs(gcce.index());
    
    if((int)((echf->stat)%2) ==1){ // odd numbers indicate well functioning cell.
      TotalHITCEnergy+=hitc1->q;
      // cell is ok
      
      // Et
      ThisEt=hitc1->q * sqrt(hitc1->x*hitc1->x+hitc1->y*hitc1->y)/1300;

      // inner
      if(echs->fdid <100){
	
	// gcce
	if (hitc1->q>5){ 
	  E_sum_in += hitc1->q;
	  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,1),float(gcce.index()),1);
	}

	// Energy density
	if (hitc1->q>2) rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,2000+trigflag),
				  hitc1->x,hitc1->y,hitc1->q);
	// Occupancy
	if (hitc1->q>2) rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,3000+trigflag),
				  hitc1->x,hitc1->y,
	                          hitc1->x*hitc1->x+
				  hitc1->y*hitc1->y );

	// EtMax
	if(ThisEt>EtMaxInn){
	  EtMaxInn=ThisEt;
	  EmaxInn=hitc1->q;
	  XInnEtMax=hitc1->x;
	  YInnEtMax=hitc1->y;
	}
      }
      // middle
      else {
	
	// gcce
	if (hitc1->q>5){
	  E_sum_mid += hitc1->q;	      	      
	  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,2),float(gcce.index()),1);
	}

	// Energy density
	if (hitc1->q>2) rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,2010+trigflag),
				  hitc1->x,hitc1->y,hitc1->q*(25/4));
	// Occupancy
	if (hitc1->q>2) rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,3010+trigflag),
				  hitc1->x,hitc1->y,
	                          hitc1->x*hitc1->x+
                                  hitc1->y*hitc1->y );

	// EtMax
	if(ThisEt>EtMaxMid){
	  EtMaxMid=ThisEt;
	  EmaxMid=hitc1->q;
	  XMidEtMax=hitc1->x;
	  YMidEtMax=hitc1->y;
	}
      }
    }
  }
  
  // energy densities for EtMax
  //rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,2001+trigflag),XInnEtMax, YInnEtMax, 1);
  //rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,2011+trigflag),XMidEtMax, YMidEtMax, 1);
  
  //
  // Now Fill BX contribution histograms
  //
  ArtePointer<DIHD>dihd(1);
  int BXnumber = dihd->bx;
  
  // Energy inner
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,1000+trigflag),E_sum_in,1);
  //if (E_sum_in>1)  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,1001+trigflag),E_sum_in,1);

  // Energy middle
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,1010+trigflag),E_sum_mid,1);
  //if (E_sum_mid>1) rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,1011+trigflag),E_sum_mid,1); 

  // Energy outer
  E_sum_all = E_sum_in + E_sum_mid;
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,1020+trigflag),E_sum_all,1);
  //if (E_sum_all>1) rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,1021+trigflag),E_sum_all,1);

  // Energy total per event
  rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,1030+trigflag),TotalHITCEnergy,1);

  // tcode == 9
  if (trigflag == 900) {
    E_tot_in += E_sum_in;
    // BX for tcode == 9
    rhp_hf1(DQ_ID(COMP_ECAL,LVL_HIT,9),float(BXnumber),1);
  } 
  
  // bx contributions
  if (r_trig>0 && r_trig%20 == 0) {
    n_mon += 1;
    rhp_hfill(DQ_ID(COMP_ECAL,LVL_HIT,20),float(n_mon), E_tot_in/20, 1);
    E_tot_in = 0;	
    r_trig = 0;
  }
  
  // tcode
  rhp_hf1( DQ_ID( COMP_ECAL, LVL_HIT, 10 ), float( tcode ), 1 );
  
  return 0; // return error code (0 = okay)
}
