
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 28 Oct 1999 (AG) use defines from DQ.h
// 01 Nov 1999 (AG) get rid of dq_hid.h
// 05 Nov 1999 (AG) improve histogramming
// 06 Dec 1999 (CP) weight occupancies by radius
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_ECAL.h"

#include <CLHEP/Hist/HBookHistogram.h>

// prototypes
void ECAL_hit_book( int tcode );

//
// function code
//
int
DQ_ECAL_hit_init()
{
  // general
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT, 1),"ECAL: gcce in", 5000 ,0.,5000);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT, 2),"ECAL: gcce mid",5000 ,0.,5000);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT, 9),"ECAL: R bx",    220,-0.5,219.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,10),"ECAL: trig",    10 ,-0.5,9.5);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,20),"ECAL: E vs. t", 1000,0,1000,50,0,100);
  
  // different trigger codes
  ECAL_hit_book( 0 );
  ECAL_hit_book( 9 );
  
  return 0;
}

//
// function code
//
void
ECAL_hit_book( int tcode )
{
  int ad = tcode * 100;

  // energies

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,1000+ad),"ECAL: E_in",    400,-0.5,399.5);
  //rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,1001+ad),"ECAL: E_in >0", 400,-0.5,399.5);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,1010+ad),"ECAL: E_m",     400,-0.5,399.5);
  //rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,1011+ad),"ECAL: E_m >0",  400,-0.5,399.5);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,1020+ad),"ECAL: E_all",   400,-0.5,399.5);
  //rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,1021+ad),"ECAL: E_all >0",400,-0.5,399.5);

  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,1030+ad),"ECAL: Total energy per event",150,0,1500);

  // energy densities
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,2000+ad),"ECAL: Energy density of inner cells",
	     70,-78.05,78.05,70,-78.05,78.05);
  //rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,2001+ad),"ECAL: Energy density of inner cells for Max Pt",
  //     70,-78.05,78.05,70,-78.05,78.05);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,2010+ad),"ECAL: Energy density of middle cells",
	     80,-223,223,80,-223,223);
  //rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,2011+ad),"ECAL: Energy density of middle cells for Max Pt",
  //     80,-223,223,80,-223,223);

  // occupancy
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,3000+ad),"ECAL: Occupancy of inner cells",
	     70,-78.05,78.05,70,-78.05,78.05);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,3010+ad),"ECAL: Occupancy of middle cells",
	     80,-223,223,80,-233,233 );
}
