 
// *****************************************************************************
//
// source:    DQ_FARM_rec_evnt.C
//
// type:      source code
//
// created:   17 Nov 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// called by: DQ_event()
//
// hints:
//            components: COMP_SVD
//                        COMP_ITR
//                        COMP_HIPT
//                        COMP_OTR
//                        COMP_RICH
//                        COMP_TRD
//                        COMP_ECAL
//                        COMP_MUON
//                        COMP_FLT
//                        COMP_SLT
//                        COMP_TLT
//                        COMP_FARM
//
//            levels:     LVL_RAW
//                        LVL_HIT
//                        LVL_REC
//
// changes:
// 17 Nov 1999 (AG) creation
// 13 Mar 2000 (AG) monitor RTRA, RSEG, RCCL, RVER
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_FARM.h"

//
// function code
//
int
DQ_FARM_rec_evnt()
{
  // DST flag
  ArtePointer<EVHD> evhd( 1 );
  int flagdst = evhd->flagdst;
  
  // fill DST flag
  rhp_hf1( DQ_ID( COMP_FARM, LVL_REC, 1 ), flagdst, 1 );

  // reco tables
  rhp_hf1( DQ_ID( COMP_FARM, LVL_REC, 10 ), ArteTable<RTRA>::size(), 1 );
  rhp_hf1( DQ_ID( COMP_FARM, LVL_REC, 11 ), ArteTable<RSEG>::size(), 1 );
  rhp_hf1( DQ_ID( COMP_FARM, LVL_REC, 12 ), ArteTable<RCCL>::size(), 1 );
  rhp_hf1( DQ_ID( COMP_FARM, LVL_REC, 13 ), ArteTable<RVER>::size(), 1 );
  
  return 0;
}
