 
// *****************************************************************************
//
// source:    DQ_FARM_rec_init.C
//
// type:      source code
//
// created:   17 Nov 1999
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// called by: DQ_init()
//
// hints:
//            components: COMP_SVD
//                        COMP_ITR
//                        COMP_HIPT
//                        COMP_OTR
//                        COMP_RICH
//                        COMP_TRD
//                        COMP_ECAL
//                        COMP_MUON
//                        COMP_FLT
//                        COMP_SLT
//                        COMP_TLT
//                        COMP_FARM
//
//            levels:     LVL_RAW
//                        LVL_HIT
//                        LVL_REC
//
// changes:
// 17 Nov 1999 (AG) creation
// 13 Mar 2000 (AG) monitor RTRA, RSEG, RCCL, RVER
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_FARM.h"

//
// function code
//
int
DQ_FARM_rec_init()
{
  cout << "DQ_FARM_rec_init()" << endl;

  // book DST flag
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_REC, 1 ), "FARM: DST flag", 2, -0.5, 1.5 );

  // reco tables
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_REC, 10 ), "FARM: RTRA", 100, -0.5, 999.5 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_REC, 11 ), "FARM: RSEG", 100, -0.5, 999.5 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_REC, 12 ), "FARM: RCCL", 100, -0.5, 999.5 );
  rhp_hbook1( DQ_ID( COMP_FARM, LVL_REC, 13 ), "FARM: RVER", 100, -0.5,  99.5 );

  return 0;
}
