
/**************************************************************/
/*         D. Dujmic                                          */
/*                                                            */
/* Declaration of Histograms                                  */
/*                                                            */
/*  1 Nov 1999 (AG) get rid of dq_hid.h                       */
/* 16 Dec 1999 (RP) histograms for fed channels and ph.det.   */
/**************************************************************/ 

#include <stdlib.h>
#include <stdio.h>

#include "rpm.h"
#include "pub.h"
#include "grr.h"
#include "rhp.h"

#include "dq/DQ.h"
#include "rich/rich.h"

float *fed_rich_buf;

void DQ_RICH_fetch_reference_histograms_magoff() {
int nevent = 5213;
float ia_rate = 10; 
float fed_occup_10Mhz[]={ 
45307.0,
33170.0,
35979.0,
58602.0,
53193.0,
65996.0,
82933.0,
87440.0,
107526.0,
109414.0,
42944.0,
51437.0,
65742.0,
39547.0,
37983.0,
101783.0,
93123.0,
155963.0,
140577.0,
51978.0,
99208.0,
62320.0,
35003.0,
80820.0,
45912.0,
87561.0,
52422.0,
32966.0
};

 unsigned int id= DQ_ID(COMP_RICH,LVL_RAW,101);
 rhp_hbook1(id,"RICH: FED Occupancy (Reference)",
	    RICH_DAQ->NumFED(),-.5,RICH_DAQ->NumFED()-.5);
 for (int i=0; i< RICH_DAQ->NumFED(); i++) {
   rhp_hf1(id,float(i),fed_occup_10Mhz[i]/(ia_rate*nevent));
 }
}


void DQ_RICH_fetch_reference_histograms_magon() {
int   nevent  = 2606;
float ia_rate = 4.9; 
float fed_occup_5Mhz[]={ 
  54487.0,
  28918.0,
  30052.0,
  49774.0,
  43645.0,
  58999.0,
  77761.0,
  92347.0,
  66510.0,
  88170.0,
  61853.0,
  89285.0,
  90604.0,
  47427.0,
  45135.0,
  68823.0,
  64256.0,
  98252.0,
  92193.0,
  43633.0,
  104739.0,
  55242.0,
  61906.0,
  80923.0,
  57404.0,
  95967.0,
  79168.0,
  67494.0,
};

 unsigned int id= DQ_ID(COMP_RICH,LVL_RAW,101);
 rhp_hbook1(id,"RICH: FED Occupancy (Reference)",
	    RICH_DAQ->NumFED(),-.5,RICH_DAQ->NumFED()-.5);
 for (int i=0; i< RICH_DAQ->NumFED(); i++) {
   rhp_hf1(id,float(i),fed_occup_5Mhz[i]/(ia_rate*nevent));
 }
}


int DQ_RICH_raw_init()
{
  printf("DQ_RICH_raw_init()\n");

  // ---- RICH initialization
  if (!RICH_DAQ) initrich_();

  // -- FED occupancy
  int nbinx=RICH_DAQ->NumFED();
  float xmin=-.5;
  float xmax=RICH_DAQ->NumFED()-.5;

  unsigned int rich_fed_histo_id=DQ_ID(COMP_RICH, LVL_RAW,100);
  unsigned int rich_fed_ratio_id=DQ_ID(COMP_RICH, LVL_RAW,102);

  rhp_hbook1(rich_fed_histo_id,"RICH: FED Occupancy (Total)",nbinx,xmin,xmax);
  rhp_hbook1(rich_fed_ratio_id,"RICH: FED Occupancy (Ratio)  ",nbinx,xmin,xmax);

  int nch=nbinx*128*8+1;
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_RAW,103),"RICH: FED channel  Occupancy ",
	     nch,-0.5,nch-0.5);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_RAW,104),"RICH: PHdet occupancy up",240,-0.5, 239.5,
	                                                              128,-0.5, 127.5);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_RAW,105),"RICH: PHdet occupancy dn",240,-0.5, 239.5,
	                                                              128,-0.5, 127.5);

  // -- fill reference histogram 
  // -- (should come from database)
  DQ_RICH_fetch_reference_histograms_magon();

  // reset fed buffer
  if (!fed_rich_buf) fed_rich_buf= new float[nch];
  float *fed=fed_rich_buf;
  for (int i=0;i<nch;i++) {
    *fed=0;
    fed++;
  } 

  // -- list booked histograms
  const int MAXHIST=100;
  static int nhist;
  static int hist_ids[MAXHIST];
  rhp_hid(0, hist_ids, MAXHIST, &nhist);
  //  printf("dmon_hpublish> Histogram list for publishing contains %d Ids:\n", 
  //	 nhist); 
  // for (int i=0; i<nhist; i++) printf("%d\n",hist_ids[i]);   

  return 0; 
}
