// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 27 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
//  4 Nov 1999 (DD) beta=1 radius histogramm 
// 19 Nov 1999 (AG) show up
// 16 Dec 1999 (RP) likelihood histograms DQ_RICH_rec_pid()
// *****************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>   

// includes
#include "dq/DQ.h"
#include "dq/DQ_RICH.h"

#include "arte/arte.hh"

#include "rhp.h"

/////////////////////  Declare RICH histograms /////////////////////////////
float DQ_RICH_rec_xmin=log(1);
float DQ_RICH_rec_xmax=log(200);
int   DQ_RICH_rec_nbin=20;

/// cherenkov angles
float DQ_RICH_rec_thc_xmin=0;
float DQ_RICH_rec_thc_xmax=0.06;
int   DQ_RICH_rec_thc_nbin=100;
int   RITERhisto=0;

int DQ_RICH_rec_init()
{
  cout << "DQ_RICH_rec_init()" << endl;

  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 200),"RICH: Number of RICH rings per event",50,-0.5,49.5);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 201),"RICH: track directions",50,-0.3,0.3,50,-0.3,0.3);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 202),"RICH: Cherenkov angle",400,0.02,0.06);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 203),"RICH: Beta=1 Cherenkov angle",400,0.02,0.06);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2000),"RICH: Beta=1 Cherenkov angle",400,0.02,0.06);

  float min = DQ_RICH_rec_thc_xmin ;
  float max = DQ_RICH_rec_thc_xmax ;
  int   bin = DQ_RICH_rec_thc_nbin ;
  RITERhisto=1;
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 204),
	     "RICH: Cherenkov angle for (track,hit) pairs M16", bin,min,max );
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 205),
	     "RICH: Cherenkov angle for (track,hit) pairs M4", bin,min,max );
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 206),
	     "RICH: Cherenkov angle for (track,hit) pairs weighted M16", bin,min,max );
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 207),
	     "RICH: Cherenkov angle for (track,hit) pairs weighted M4", bin,min,max );

  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 210),"RICH: rtra id={other,e,mu,pi,K,p}"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 211),"RICH: rtra->lre"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 212),"RICH: rtra->lrmu" ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 213),"RICH: rtra->lrpi" ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 214),"RICH: rtra->lrk"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 215),"RICH: rtra->lrp"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 216),"RICH: rtra->lrother",100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 217),"RICH: rtra->hri",100,0,100);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 218),"RICH: rtra->flr",100,0,100);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 219),"RICH: rtra->flr/allrtra",100,0,1);

  float xmin = DQ_RICH_rec_xmin ;
  float xmax = DQ_RICH_rec_xmax ;
  int   nbin = DQ_RICH_rec_nbin ;

  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 220),"RICH: log(rtra->lrpi/rtra->lrk)(log(p))"  ,nbin,xmin,xmax,100,-100,100);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 221),"RICH: rtra->lre(log(p))"  ,nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 222),"RICH: rtra->lrmu(log(p))" ,nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 223),"RICH: rtra->lrpi(log(p))" ,nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 224),"RICH: rtra->lrk(log(p))"  ,nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 225),"RICH: rtra->lrp(log(p))"  ,nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 226),"RICH: rtra->lrother(log(p))",nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 227),"RICH: rtra->hri(log(p))",nbin,xmin,xmax,100,0,100);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 228),"RICH: rtra->flr(log(p))",nbin,xmin,xmax,100,0,100);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 229),"RICH: rtra->flr/allrtra(log(p))",nbin,xmin,xmax,100,0,1);


  return 0; // return error code (0 = okay)
}



