
// ******************************************************************
//
// 
// M. Braeuer / D. Samtleben
// Filling of histograms for VDS
//
// changes:
// 28 Oct 1999 (AG)  use defines from DQ.h
// 01 Nov 1999 (AG)  get rid of dq_hid.h
// 03 Nov 1999 (AG)  repair hist id
// 10 Dez 1999 (MBr) update/major revision
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte include
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_SVD.h"

// from Alignment stuff:
inline int fUnsin(int sl,int sec,int lay) { 
  int i = (lay-1)+(4*(sec-1))+(16*(sl-1));
  return(i); 
}


//
// function code
//
int
DQ_SVD_rec_evnt()
{
  //cout << "DQ_SVD_rec_evnt()" << endl;
  
  int nrSVDtracks=0;
  int nrVDStrackhits=0; // no of track associated hits/event
  
  for(ArteTableIterator<RSEG> track;track.valid();track.next()){
    float tx=track->txf;
    float ty=track->tyf;
    
    /* VDS Modified !!================================== */
    
    if(track->cmp ==1||track->cmp==65537){ 
      int VDShitstontrack = 0;
      float VDSxp1,VDSyp1,VDSxp2,VDSyp2,VDSres, VDSocc, VDSusid;
      float VDSx = track->xf;
      float VDSy = track->yf;
            
      // loop over the hits of track      
      for ( ArteRelationIterator<HITB> hitbIt = track->hitb.begin();
	    hitbIt != track->hitb.end(); ++hitbIt ) {
	ArtePointer<HITB> hitb(hitbIt);
	ArtePointer<GEDE> gede(hitb->gede);
	
	// calculate the plane ID:
	VDSusid = float(fUnsin(gede->gesl->nsl,gede->sec,gede->lay) ); 

	// increase number of hits per track:
	++VDShitstontrack;
	++nrVDStrackhits;
	
	// book residuals:
	VDSxp1 = VDSx + tx*( (gede->zmax+gede->zmin)/2 - track->zf ); 
	VDSyp1 = VDSy + ty*( (gede->zmax+gede->zmin)/2 - track->zf );
	VDSxp2 = VDSxp1*gede->rot[0] + VDSyp1*gede->rot[1];
	VDSyp2 = VDSxp1*gede->rot[3] + VDSyp1*gede->rot[4];
	VDSres = 1000 * (hitb->x - ((VDSxp2*gede->cos) - (VDSyp2*gede->sin) ));
	rhp_hf1(DQ_ID(COMP_SVD,LVL_REC,203),        VDSres,1); // to total residual
	rhp_hfill(DQ_ID(COMP_SVD,LVL_REC,204),VDSusid,VDSres,1); // to residual
	
	// the occupancy:
	VDSocc = (hitb->x - gede->xfw[0]) / gede->pit;
	rhp_hfill(DQ_ID(COMP_SVD,LVL_REC,202),VDSusid,VDSocc,1); // to residual
	
      } // end of loop
      VDSxp1 = VDSx + (tx * (100 - track->zf));
      VDSyp1 = VDSy + (ty * (100 - track->zf));
      rhp_hfill(DQ_ID(COMP_SVD,LVL_REC,205),10*VDSxp1,10*VDSyp1,1); // to refplane
      rhp_hf1(DQ_ID(COMP_SVD,LVL_REC,201),VDSusid,1);
      nrSVDtracks++;
    } // if VDS-track (rseg->cmp==1)
    
    /* End of VDS modified ============================= */
  }
  rhp_hf1(DQ_ID(COMP_SVD,LVL_REC,200),nrSVDtracks,1);
  rhp_hf1(DQ_ID(COMP_SVD,LVL_REC,206),nrVDStrackhits,1);
  
  return 0; // return error code (0 = okay)
}







