
      SUBROUTINE CRROTM(IROT,TH1,PH1,TH2,PH2,TH3,PH3)
************************************************************************
*
* CRROTM
* This routines creates a rotation matrix on the next free place
* written by Siegmund Nowak 96/12/09
* updated by Alexander Lanyov to check whether the wanted matrix already exists
*
* called from different geometric routines
*
* Arguments same as in GSROTM (see GEANT-Manual GEOM200-1)
************************************************************************

      INTEGER IROT
      REAL TH1,PH1,TH2,PH2,TH3,PH3
#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcnum.fi"
#include "arte/Arte.ff"

c check first the current rotation matrix
        IF (IROT.GE.1 .AND. IROT.LE.NROTM) THEN
           L = LQ(JROTM-IROT)
           IF (L.NE.0) THEN
              IF (ABS(Q(L+11) - TH1) .LT. 1.E-5
     @      .AND. ABS(Q(L+12) - PH1) .LT. 1.E-5
     @      .AND. ABS(Q(L+13) - TH2) .LT. 1.E-5
     @      .AND. ABS(Q(L+14) - PH2) .LT. 1.E-5
     @      .AND. ABS(Q(L+15) - TH3) .LT. 1.E-5
     @      .AND. ABS(Q(L+16) - PH3) .LT. 1.E-5) GOTO 999
           END IF
        END IF

      DO IROT=1,NROTM
       L = LQ(JROTM-IROT)
       IF(L.NE.0) THEN
          IF     (ABS(Q(L+11) - TH1) .LT. 1.E-5
     @      .AND. ABS(Q(L+12) - PH1) .LT. 1.E-5
     @      .AND. ABS(Q(L+13) - TH2) .LT. 1.E-5
     @      .AND. ABS(Q(L+14) - PH2) .LT. 1.E-5
     @      .AND. ABS(Q(L+15) - TH3) .LT. 1.E-5
     @      .AND. ABS(Q(L+16) - PH3) .LT. 1.E-5) GOTO 999
       ELSE 
          CALL GSROTM( IROT, TH1, PH1, TH2, PH2, TH3, PH3)
          GO TO 999
       ENDIF
      ENDDO
      IROT = NROTM+1
      CALL GSROTM( IROT, TH1, PH1, TH2, PH2, TH3, PH3) 
      print *,'crrotm',IROT,NROTM      
c      CALL MEERRO('no place for rotation matrix in CRROTM')
 999  RETURN
      END
