/***********************************************************************
*-- Author :    Siegmund Nowak   04/03/93
*
* This routines avoids long spirals in magnetic field
* ISTOP will be set to 1 in this case
* former subroutine name nspirl.F
*
* called from GUSTEP
*
***********************************************************************/
#include <stdio.h>
#include <math.h>
#include "gean/gckine.h"
#include "gean/gctrak.h"
#include "gean/gctmed.h"
#define EC      2.9979251E-4      
#define ANGSPR  94.25


extern "C" {
  void gufld_( float [], float []);
}

  void gspiral();
  static int nspirl_first = 1;

void gspiral() {
   extern float nspirl_angle; 
   static int itra_old, istak_old,  nstep_old;
   static float slen0, fld0, phi;
   if(nspirl_first) {
      itra_old =0; istak_old = -1; nstep_old = 100000;
      nspirl_first = 0;
   }

//      if(angspr == 0.) return;

   float field[3];
   gufld_(gctrak_.vect,field);
   if(fabs(field[1]) < 1.E-3 ) return;

   if(gckine_.itra != itra_old || gckine_.istak != istak_old 
                               || gctrak_.nstep <  nstep_old) {
      itra_old  = gckine_.itra;
      istak_old = gckine_.istak;  
      nstep_old = gctrak_.nstep;
      slen0     = gctrak_.sleng; 
      fld0      = field[1];
      phi       = 0.;
   }    
   else { 
      for (int j = 0; j< gctrak_.nmec; j++) {
         if(gctrak_.lmec[j] != 4) continue;
         phi += (gctrak_.sleng - slen0)*EC*gckine_.charge*0.5*(field[1]+fld0)/
             (gctrak_.vect[6]*sqrt((1.-gctrak_.vect[4])*(1.+gctrak_.vect[4])));
         if(fabs(phi) > nspirl_angle) {
            gctrak_.istop = 1;
            return;
         }
         fld0 = field[1];
         slen0 = gctrak_.sleng;
      }
   }
}

