>Name HGKUIP

>Menu HBGEAN
>Guidance
HBGEAN = HERA-B GEANT specific commandOss.
**********************************************************************
**********************************************************************
>Menu /HBGEAN/GENERAL
>Guidance
Possibilities of HBGEAN:

 HBGEAN consists of a set of subroutines and data files, which:
 - create geometry structures for use in GEANT and ARTE; alternatively
 these geometry structures can be read in if they were prepared in a
 previous run. The creation of geometry structures will be done from the
 HERA-B-database, as long as no data base exists from an ASCII file
 hbgeo.dat (other names are possible -  see menu geodat)

 - trace tracks through the detector and show up (write out)
 their interactions with detector components.
 - draw the detector or parts of it and also tracks.
 - make CAD files of the detector implementation.

 The HERA-B GEANT simulation software is organized with the Source Code
 Management System CMZ. The name of the cmz-file is hbgean.cmz. To get
 an executable program the CERN-library of GEANT (version 3.21)
 is required.

 The new versions (version 2.00/00 and bigger) of HBGEAN are
 implemented in the ARTE program. Therefore the main program must
 have a CALL ATMAIN. HBGEAN  will be activated by a steering command
 (card) GEAN in the ARTE command file.

 HBGEAN expects event or track data from an event generator
 or from files, they must be given in ARTE format (ZEBRA-banks). If
 reading from files events of different channels can be merged to one
 superevent before tracing through the detector. During the tracing
 histograms can be made and analysed directly or GEANT-hits (MIMPS)
 can be written out for further analysis in subsequent programs.

 Most of the general GEANT control cards are valid. For details see menu
 geankumac
.
**********************************************************************
***********************************************************************
>Menu /HBGEAN/STRUCTURE
>Guidance
 Structure of hbgean.cmz
 The hbgean.cmz is divided into the following subdirectories:
 GCDES321: all sequences/commons of CERN GEANT.
 hgcdes  : all sequences/commons for HBGEAN.
 hg      : interface routines to ARTE.
 geom    : subroutines for the detector geometry.
 media   : subroutines for the detector materials.
 kine    : subroutines for particle definition, kinematics, tracking.
 cr      : subroutines for creating ARTE banks.
 gobj    : subroutines which exist also in other libraries.
 pict    : some drawing routines.
 kuip    : all HBGEAN-KUIP routines for interactive work.
 data    : the hbgeo.dat file for the given hbgean-version and an example
           for geant-data cards inside the ARTE kumac file.
.
 To be shure that hbgean routines whose name exist also in other libraries
 will be taken, they should be always loaded as object files.

 The interplay between ARTE and HBGEAN will be realized by the following
 subroutines:
 ATINIT calls:
    HGVERS (gives out the HBGEAN version number).
    GINTRI (sets the keys for HBGEAN commands in the ARTE kumac file).
    GINIT  (sets the default values for GEANT variables).
 ATEXEC calls:
    KUEXEC which calls KAGEAN to activate HBGEAN by setting the variable
           GEANINIT =1 and calling HGINIT;
    HGINIT (initialization of GEANT Zebra banks, particle code, setting
            up the geometry  and the physical processes for tracing).
 ATEVNT calls:
    HGEVNT (event processing (called if GEANINIT=1) and call for HGKINE
            for setting up the event kinematic)..

 From here it follows that GEANT input card in the ARTE kumac file
 which control the physical processes or the geometry implementation
 must be given in before the activation of GEANT (command GEAN) - see
 the example file.

 Inside the event processing there is a GEANT specific routine USSTEP where
 the user can react in every tracing step (fill histograms etc);
**************************************************************************
**********************************************************************
>Menu /HBGEAN/hbgeodat
>Guidance
Explanation of hbgeo.dat and COMMONS ZGxxxx.

>Help_item ZGMOTH
>Guidance
Short description of MOTHER volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 XMOT(1..3) [XMOT,YMOT,2*ZMOT] Dimensions of the mother volumen (pyramid)
                               xmot, ymot are related to the small side
 ZZCO       [ZZERO]            position of the coordinate origin in mother
 THAN(1)    [THXMX1]           angular limit for chambers and rich in x
                               this is the opening angle in x of pyramid
 THAN(2)    [THXMX2]           angular limit for calo and muon system in x
 THAN(3)    [THYMX]            angular limit in y (opening angle in y)
 THAN(4)    [THMIN]            minimum cut for theta
 SXBM(10)   [SIGXBM]           HORIZONTAL BEAM WIDTH
 SYBM(11)   [SIGYBM]           VERTICAL BEAM WIDTH.
.

>Help_item ZGOTR
>Guidance
Short description of WIRE CHAMBER volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 NSLWT                  MAX NUMBER OF WT SUPERLAYERS
 NSCWT                  Max number of sectors
 DEWT(I)                NAME OF CHAMBER SUPERLAYER I
 ZAWT(I),DLWT(I)        CENTRAL POSITION AND THICKNESS IN Z FOR SUPERLAYERS
 NPWT(I)    [NPLWT(I)]  NUMBER OF PLANES in SUPERLAYER I
 NSWT(I)    [NSECWT(I)] NUMBER OF sectors in SUPERLAYER I
 NWWT(ISL,ISEC)[NWIRWT] number of wires in sector ISEC of superlayer ISL
                        if le 0 no sector ISEC exists
 IRWT(I)    [IROWT(I)]  rotation sign of the planes ie. for NPLWT=6
                        102102= +0-0+0- for single layers, add 3 for double
 DIWT(1.14) [DLWAWT,DLTOWT(4),DLS1WT,DLS2WT,DLCLWT(4),DLWEWT,DLOVWT,XYOVWT]
                        thickness of support wall, total width of one
                        layer(4 types), straw material (2 components are
                        possible), cell thickness (4 types), dividing foils
                        between chambers, overlap in z and x/y direction
 ANWT       [ANGWT]     angle of the stereo chambers (common for all SLs)
 EFWT       [EFFWT]     efficency for honeycomb chambers
 ACWT(1..4) [SIGWT(4)]  resolution for four chamber types
 PIWT(1..4) [PITWT(4)]  wire distance for honeycomb chambers
 DMWT(1..4) [DIMXWT(4)] maximal drift distance in honeycomb chambers
 XOWT(ISL,ISEC)         outer x boundary for superlayer ISL
 YOWT(ISL,ISEC)         outer y boundary for superlayer ISL
 XLWT(ISL,ISEC)         left side boundary for sectors (see sketch )
 XRWT(ISL,ISEC)         right side boundary for sectors (see sketch )
 YLWT(ISL,ISEC)         low side boundary for sectors (see sketch )
 YRWT(ISL,ISEC)         up side boundary for sectors (see sketch )
                        first index superlayer, second index sector
 Four Chamber types : 1  Aachen type single layers 10 mm cell diameter
                      2    "     "     "      "     5 mm  "      "
                      3    "     "   double   ""    10 mm  "      "
                      4    "     "     "      "     5 mm  "      "
 Aachen type means:
                                                      _   _   _   _    .
                                                     / \_/ \_/ \_/ \_  .
              _   _   _                              \_/ \_/ \_/ \_/   .
   single   _/ \_/ \_/ \_/             double       _/ \_/ \_/ \_/ \_  .
             \_/ \_/ \_/ \                           \_/ \_/ \_/ \_/   .
            _/ \_/ \_/ \_/                          _/ \_/ \_/ \_/ \_  .
.
 WTDT(1..8)             Name of the four chamber types outside and inside
                        magnetic field (CHUDET in GSDET)
.

    ------------------------------------------------------------ +YO
    |           |      |                   |       |           |
    |           |      |(15)    1      (13)|       |           |
    |           |      |                   |       |           |
    |           |   9  |-------------------|   7   |           | +YR
    |           |      |    |         |    |       |           |
    |           |      |  5 |         | 3  |       |           |
    |    12     |------+----|         |----+-------|     11    |   0
    |           |      |    |         |    |       |           |
    |           |      |  6 |         | 4  |       |           |
    |           |      |-------------------|       |           | -YR
    |           |  10  |                   |   8   |           |
    |           |      |(16)    2      (14)|       |           |
    |           |      |                   |       |           |
    ------------------------------------------------------------ -YO

   -XO         -XM    -XI  -XR   0   +XR  +XI     +XM         +XO

    (13) - (16) are the dummy (insensitive) prolongations of 3 - 6
.


>Help_item ZGPTCA
>Guidance
Short description of B->pi+pi- Trigger Pad Chambers volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
 DEPT          [DEPT]      Names of Pad Chamber Detector Layers
 ZPTC(1..NLPT) [ZAPTCA]    Start Position of the  Pad Chamber Layers
 NSPT          [NSPTCA]    Number of Section in the (i)th Layer
 ITPT(1..NLPT) [ITPTCA]    Shift-flag of the Superlayer
 XSPT(1..NSPT) [XSPTCA]    X position   for (i)th section in the 1st Layer
 XAPT(1..NSPT) [XAPTCA]    X SIZE   for (i)th section in the 1st Layer
 YSPT(1..NSPT) [YSPTCA]    Y position   for (i)th section in the 1st Layer
 YAPT(1..NSPT) [YAPTCA]    Y SIZE   for (i)th section in the 1st Layer
 ZSPT(1..NSPT) [ZSPTCA]    Z-shift with respect to Z=ZPTC for (i)th Section
 DSPT(1..NSPT) [DSPTCA]    Thickness   for (i)th section in the 1st Layer
 IMPT(1..NSPT) [IMPTCA]    Media flag for (i) section
 NXPT(1..NSPT) [NXPTCA]    Number of X subdivision in (i)th section
 NYPT(1..NSPT) [NYPTCA]    Number of Y subdivision in (i)th section
 TPPT(1...5  ) [TPTG1N..]  thickness of different materials
 ADPT(1..100)  [ADPTCA]    Some additional parameters
 IDPT(1..100)  [IDPTCA]    Some additional parameters
.
>Help_item ZGTRDE
>Guidance
Short description of TRD (tracker and no tracker) volumen data cards.
.
Name before []=geo.dat name, inside []=names in Common; no[] = identical name
.
            [NSLTS]  maximal number of TRD BLOCKS
 ZATS,DLTS           START POSITION AND LENGTH OF forward TRD
 RATS       [DLRATS] THICKNESS OF RADIATOR
 STTS       [DLSTTS] THICKNESS OF STRAW MATERIAL
 GATS       [DLGATS] THICKNESS OF STRAW GAS
 WITS       [DLWITS] THICKNESS OF WIRES
 WATS       [DLWATS] THICKNESS OF WALL SUPPORT
 NPTS(i) [NPLTS] NUMBER OF RADIATOR PLANES IN forward TRD superlayer i
 XLTS(i),XRTS(i),YLTS(i),YRTS(i) - foreseen for x/y structure
 XITS,YITS           x/y dimensions of beam hole (half width)
 ALTS,BETS  [ALFATS,BETATS] angles of geometrical configuration (x and y)
.

**********************************************************************
************************************************************************
>MENU /HBGEAN/geankumac
>Guidance
Example of a arte.kumac file used for HBGEAN

 For HBGEAN most of the general GEANT interactive commands (see GEANT
 manual section XINT) are valid. Note that due to ambiguities some of
 GEANT command should be preceeded by GEANT/CONTROL/, GEANT/GEOMETRY/ or
 GEANT/PHYS. This is valid for instance for:
 GEANT/CONTROL/DEBUG
 GEANT/CONTROL/PRINT
 GEANT/PHYS/CUTS

 The following command must be replaced:
 TRIG by RUN
 NEXT by CLEAR

 If commands are not explicitely given the default values of GEANT (see
 GEANT manual BASE040) will be taken.
 .
 All drawing commands will work only, if grafic initialization is made
 before by the command PRISM

 Below an example of a arte.kumac file for usage of GEANT is given.

 *  seed 999 999
 *  LUND bb in 4. -b.
 *  exec /home/hydra/albrecht/anew/psik0
 *  IOFILE   GEOMIN hb1.geo
 IOFILE   READ geo.dat
 IOFILE   GEOMOUT hbm.geo  0  O
 IOFILE   EVIN1 /net/sgi/herab/data/jpsik0sal.dst
 IOFILE   EVIN2 /net/sgi/herab/data/inelal.dst
 IOFILE   PRISM hist.ps
 IOFILE   RAW bb.dst 0 O
 IOMIX    -1.  4.
 HBOOK gean.his -O
 GEANT/CONTROL/DEBUG  ON
 GEANT/CONTROL/SWIT 1 0
 GEANT/CONTROL/KINE 2
 GEANT/PHYS/CUTS .001 .001 .01 .01 .01 -1. -1. -1. -1. .01
 DETV TARL SIDL WTDL MTDL PTLL RICS CALL MUDL TRDS FLDS
 GEAN
 MIMP ON
 MMWRIT GEOMOUT GEHD
 RUN 3
 ENDKUMAC

 Most of the cards are explained in ARTE.
 Here the command MIMP tells the program whether MIMP should be written out
 (ON) or not (OF).  GEANT/CONTROL/SWIT 1 1 sets the Variable ISWIT(1) to 1,
 activating the event drawing ((if grafics was initiated by PRISM) .
 Otherwise the event drawing will be supressed (default). ISWIT(1) is the
 only switch used by HBGEAN, ISWIT(2-10) can be used by the user. If a
 command  IOFILE   GEOMOUT exists MMWRIT GEOMOUT GEHD  writes out the
 ARTE geometry banks. DETV and KINE will explained below:

**********************************************************************
**************************************************************************
>MENU /HBGEAN/COMMANDS
>Guidance 
Specific GEAN commands for HERA-B
***************************
>Command SETENV
>Guidance
Performs SETENV(name,value).
If envoked without parameters, shows all current and default values.
>Action kasete
>Parameter
+
name 'Variable name' C D=' '
value 'Variable value' C D=' '
*******************************************************************
>Command PHSP
>Guidance
Generates phase space particles
>Action KAPHSP
>Parameter
CPART 'Arte name of the wanted particle' C D='mu-'
PMIN  'minimal momentum' R D=10.
PMAX  'maximal momentum' r D=10.
THMIN 'minimal polar angle' R D=0.010
THMAX 'maximal polar angle' R D=0.250
PHIMIN 'minimal azimut angle' R D=0.
PHIMAX 'maximal azimut angle' R D=6.283185307




*************************************************************************
>Menu /HBGEAN/SHOW
>Guidance
Shows detector characteristics.
******************************
>Command PICT
>Guidance
Draws a perspective view of the  HERA-B-detector or of parts of it.
Possible parameters: DET SVD OTR ITR PT ECA MUON BEAM
>Action kapict%C
>Parameter
DET  ' Detector part (DET SI OTR ITR PT TRD CAL MUON BEAM) ' C D='DET'
PERS 'Perspective (p) or cut (cx or cy) view' C D='P'
+
NAM  'Superlayer name' C
LAY  'Layer number' I
SEC  'Sector number, 0 means all sectors' I D=0

*******************************
>Command PITEXT
>Guidance
Draws text.
If invoked with zero coordinates, asks for graphical input.
>Action PITEXT
>Parameter
x      'x' R D=0.
y      'y' R D=0.
string 'String to draw' C D=' '
+
color     'color (0 means no change)' R D=0.
height    'height (0 means 0.03 of viewport)' R D=0
font      '10*font+precision (see HIGZ manual, p.39)' I D=-130
alignment 'alignment: 0=10=left, 20=cent, 30=right, 0=base, 1=2=top, 3=mid' I D=0
********************************
>Command PIGSET
>Guidance
Shows and sets parameters of HIGZ graphical package.
Performs CALL IGSET(attribute,value).
See HIGZ manual, p.90 for meaning of attributes.
If invoked without parameters, shows all current and default values.
>Action PIGSET
>Parameter
+
attribute  'Attribute' C D='SHOW'
parameter  'Parameter' R D=0.

**************************
>Command GEANPRIS
>Guidance
Draws a Geant view over existing PRISM picture
Parameter MODE=1 means Geant DCUT command (cut view),
          MODE=2 means Geant DRAW command (3D view).
Supported Prism views are: 0 (xy plane), 1 (xz), 2 (yz), 3 (3D view).

At the end displays the corresponding interactive Geant command.
To use it interactively, perform a graphical reset before it (command GRESET),
and perform FLUSH after it.
>Action PIGEPR
>Parameter
+
VOLNAM 'Volume name to draw' C D='MOTH'
CUTVAL 'Cut value for DCUT' R D=0.
MODE   'Mode number' I D=1 R=1:2
HBGEAN 'Wether to draw HbGeant: 0 - not to draw' I D=1 R=0:1


>Command FLUSH
>Guidance
Flushes HIGZ graphical buffer: finally you can see your GEANT drawing!
>Action PIFLUS
>Parameter

>Command GRESET
>Guidance
Perform graphical reset after PRISM stuff.
(Switch to normalization transformation NT=1
returning to default Geant user coordinates U and V).
See also Prism command SELNT.
>Action PIGRST
>Parameter
******************************
>Menu Particle_colours
>Guidance
The following colours are used for drawing the particle tracks:
  Leptons from J/Psi                            black *
  K0s products from J/Psi                       green *
  Tagging particles                             yellow *
  Hadrons                                       red
  Electrons/photons                             blue
  Muons                                         violet

  charged particles                             solid lines
  neutral particles                             dotted lines (if drawn)

  * if golden particles are selected
*************************************************************************
********************************************************************
>MENU /HBGEAN/GEOM
>Guidance 
Geometry commands
***************************
>Command VERS
>Guidance
Definition of the geometry version for HBGEAN
>Action kageov%C
>Parameter
GEOMVERS 'GEOMETRY version' R D=0.
***************************
>Command DETV
>Guidance
 This command rejects subdetector completely from the geometry installation.
 The syntax is 
 DETV subdetector1 subdetector2 ...
 where  subdetector1/subdetector2 can be 'SVD OTR ITR PTC RIC TRD ECA MUON' 
>Action GEOACT
>Parameter
DETV 'reject subdetector(s)' C VARARG LOOP
***************************
>Command MAGNET
>Guidance
switches magnet ON or OFF
>Action kamagn%C
>Parameter
MAGNFL 'MAGNET_FLAG' C
+
REVFL  'Reversion flag' C D=' '
***************************
>COMMAND WIRE
>Guidance
changes the effectivity of wire materials.
>ACTION kawire%C
>PARAMETER
+
SELPAR 'selection parameter (1all, 1i,1o,1t,1b, 2i, 2o, 2t, 2b or MAT' C D=' '
VALPAR 'effectivity for wires or material name for MAT' C D=' '


********************************************************************
********************************************************************
>MENU /HBGEAN/TRACE
>Guidance 
Tracing  commands
***************************
>COMMAND TURB
>Guidance 
switch on fast electron tracing in muon system
>ACTION katurb%C
>PARAMETER
TURB   'switch off slow electron tracing in muon system' C D='off'
********************
>COMMAND CKOV
>GUIDANCE
switch off cerenkov photon generation .
>ACTION katrace%C
>PARAMETER
+
CKOV 'switch for Cerenkov generation' C  D='ON'

***************************
>COMMAND TRD
>GUIDANCE
switch off TRD photon generation .
>ACTION katrace%C
>PARAMETER
+
TR48 'switch on/off' C  D='OFF'

***************************
>COMMAND NSPIRL
>Guidance
defines the maximal angle for spiraling particles
>ACTION kaspirl%C
>PARAMETER
nspirl_angle 'maximal angle for spiraling particles' R D=94.25

***************************
>COMMAND PBEAM
>GUIDANCE
switches generation time smearing or beam shift on or out  
>ACTION kabeam%C
>PARAMETER
TYPE     'TIME or SHIFT' C D='SHIFT', R='TIME','SHIFT'  
ITGTIM   'switch on or off of generation time' C D='off' R='on','off'
+
SIGMA    'sigma in ns for bunch spread' R  D=1.
MEAN     'time shift in ns'             R  D=0. 



********************************************************************
>Menu /HBGEAN/OTR
>Guidance
OTR-specific commands.

>Command OTRG10
>Guidance
This command sets condition whether G10 strips will be declared
as walls and Geant volumes during definition of OTR geometry.
In total, G10 strips have much less material than pokalon modules themselves,
so it is usually safe to ignore the material of G10 strips.
Please note that this command has effect only if used before GEAN command

Meaning of mode parameter:
 OFF            - not declare
 ON             - declare G10 strips
 CONCISE        - (not yet implemented!) declare G10 strips in concise way
                  by grouping strips at approximately the same
                  position as one wall
 <no parameter> - show current status

>Action WALLG10
>Parameter
+
Mode 'Mode: OFF - not declare, ON - full declare, CONCISE - declare in concise way' C D=' '

********************************************************************
>MENU /HBGEAN/PTL
>Guidance
commands for high pt cchambers
>Command PTLPRINT 
>Guidance 
  Print information about PTL chambers and walls (using only PTGE table)
  Perform scan PTGE table from row FIRST to row LAST and print information
  about all objects which satisfy the selection criteria: 
        NAME , OBJECTS, SUPERLAYER and MOTHER
  Suitable for fast finding of the object. 
  FIRST = MIN( MAX( 1     , FIRST ) , NPTGE() )
  LAST  = MIN( MAX( FIRST , LAST  ) , NPTGE() )
  Example: 
   PTLPRINT 1 50 ALL WALL ALL ALL TPL TABLE  - will scan first 50 rows in 
     PTGE table and print information about all OBJECTS of type=WALL  
>Action PTLPRN
>Parameters 
+
FIRST       'First object to be printed                          ' I D=1 
LAST        'Last  object to be printed                          ' I D=10000 
NAME        'Name of object to be printed                        ' C D='ALL'  
OBJECTS     'Chambers?Walls?All?                                 ' C D='ALL'  
SUPERLAYER  'Print objects which belongs to THIS superlayer only ' C D='ALL' 
MOTHER      'Print objects which belongs to THIS mother only     ' C D='ALL'
DESTINATION 'Printer destination: any combination of T , P and L ' C D='TPL'
FORMAT      'Format: FILE or TABLE                               ' C D='TABLE'

>Command PTLLIST 
>Guidance 
  List  information about PTL chambers and walls (using only PTGE table)
  action is almost the same as for PTLPRINT command. 
  Perform scan PTGE table from row FIRST to row LAST and list information
  about all objects which satisfy the selection criteria: 
            NAMES , OBJECTS , SUPERLAYER and MOTHER
   Suitable for detailed description and for ASCII-file creation.  
   FIRST = MIN( MAX( 1     , FIRST ) , NPTGE() )
   LAST  = MIN( MAX( FIRST , LAST  ) , NPTGE() )
  Example: 
   PTLLIST 1 0 PTC1 ALL ALL ALL TPL FILE  - will scan all PTGE table, 
   and list information about all OBJECTS with name PTC1 
>Action PTLPRN
>Parameters 
+
FIRST       'First object to be listed                           ' I D=1 
LAST        'Last  object to be listed                           ' I D=10000 
NAME        'Name of object to be listed                         ' C D='ALL'  
OBJECTS     'Only Chambers? Only Walls? All?                     ' C D='ALL'  
SUPERLAYER  'List objects which belongs to THIS superlayer only  ' C D='ALL' 
MOTHER      'List objects which belongs to THIS mother only      ' C D='ALL'
DESTINATION 'List destination: any combination of T , P and L    ' C D='TPL'
FORMAT      'Format: FILE-like or TABLE-like                     ' C D='FILE'

>Command PTLDRAW
>Guidance 
 call GDRAW or GDRAWC for PT SUPERLAYERS 
>Action  PTLDRW
>Parameters 
PERS    ' DRAW(D) or CUT(c) view ' C D=D
SUPL    ' Superlayer name        ' C D='PTL1' R='PTL1','PTL2','PTL3','MAGN','MOTH'
THETA    'angle THETA for GDRAW  ' R D=20.0
PHI      'angle PHI   for GDRAW  ' R D=45.0
PSI      'angle PSI   for GDRAW  ' R D=0.0
AXE      'Axis of the GDRAWC     ' I D=3 
CUT      'cut value for GDRAWC   ' R D=0.0
U0       'U0                     ' R D=10.0  
V0       'V0                     ' R D=10.0  
SU       'SU                     ' R D=0.1  
SV       'SV                     ' R D=0.1  

>Command PTLREAD  
>Guidance 
Force the reading of PT-geometry information and put it into Arte table PTGE. 
Existing PTGE table will be removed. New information in PTGE Arte table 
*can differ* from existing GEANT JVOLUM structure. Therefore be carefull 
using this command. Currently onlu SOURCE=File is implemented.   
Being frequently used within one ineractive job this command *can force* 
Arte  termination via "no place for rotation matrix in CRROTM" error. 
>Action PTLREA 
>Parameters 
+
SOURCE 'where the information should be read from?File?DBase?' C D='FILE' 






