        subroutine  otwall(covthick)
******************************************************************
*
* Defines walls for OTR.
*
* Now, only superlayer cover is defined.
* To do next: caps, inner frame, outer frame.
*
* Called from: otrgeo.F
*
* Arguments  in/out       Description
*
* covthick   in/out       cover plate total thickness in cm
*                         (may be overwritten for run 99)
*
* Alexander Lanyov     Mar 1999
*
************************************************************************
        implicit none

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGMOTH.fi"
#include "gean/ZGBPIP.fi"
#include "gean/ZGOTR.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"

#include "gean/otrgeo.fi"

        integer isl,mf,dir
        real par(8),z1,z2,dist,fiberthick,covthick
        character*4 csl,comb,fiber

#include "arte/Arte.ff"
#include "auto/GEO.ff"

c-- install the superlayer volume
        call uhtoc(hnesl_name(currsl),4,csl,4)
        nsl = inesl_nsl(currsl)
        mf = inesl_mfl(currsl) + 1

        if (covthick.le.0.) then
	   c78 = 'Illegal cover thickness:'
	   call ch78bf(covthick,-2)
 	   call ch78bc(' cm')
           call meerro (c78)
        end if

	if (csl(:2).eq.'MC'
     @     .and. ichar(csl(4:4)).le.ichar('5')) then  ! MC01-MC05
           if (mf.eq.1) then
   	      comb = 'WTCF'   ! carbon fiber
           else
   	      comb = 'WTCI'
           end if
           dist = 0.15
           fiberthick = 0.
	else if (csl(:2).eq.'MC') then                ! MC06, MC08
           if (mf.eq.1) then
   	      comb = 'WTPH'   ! paper honeycomb
           else
   	      comb = 'WTPI'
           end if
           dist = 0.15
           fiberthick = 0.05
	else if (csl(:2).eq.'PC') then                ! PC
	   comb = 'WTPH'
           dist = 0.5
           fiberthick = 0.1
	else if (csl(:2).eq.'TC') then                ! TC
	   comb = 'WTAH'
           dist = 0.5
           fiberthick = 0.1
	else
	   call meerro('OTWALL: Wrong superlayer name: '//csl)
	end if

	if (csl.eq.'TC02' .and. xmax_all.lt.-20 ) then   ! mini-TC in run 99
           covthick = 0.4
	   comb = 'WTAL'
           dist = 0.5 * (8. - zmax_all + zmin_all)
           fiberthick = 0.
        end if

        if (mf.eq.1) then
           fiber = 'WTGF'
        else
           fiber = 'WTGL'
        end if

c-- install the front/back plates of the gas box
        do dir=-1,1,2
           if (dir.eq.-1) then
              z1 =  zmin_all - dist   ! dir=-1: front plate
           else
              z1 =  zmax_all + dist   ! dir=+1; back plate
           end if
           z2 = z1 + dir*fiberthick
           if (fiberthick.ne.0.) call otrcov(fiber,z1,z2)

           z1 = z2
           z2 = z1 + dir*(covthick - 2.*fiberthick)
           call otrcov(comb,z1,z2)

           z1 = z2
           z2 = z1 + dir*fiberthick
           if (fiberthick.ne.0.) call otrcov(fiber,z1,z2)

        end do

        return
        end
