*-- Author :    Hartwig Albrecht   21/05/95

      SUBROUTINE KADRAN (IFLAG)

************************************************************************
*
* Description: range commands
*
* Called from: KADIRA, KADILO, KADIUP, KADFRA, KADDLO, KADFUP, KADNBI
*
* External references:
*
* Arguments: IFLAG: which range specification
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDCOM.fi"
#include "arte/ZDDEFP.fi"

      INTEGER IFLAG

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      IF (NDDTYP .EQ. 0)  THEN
        CALL MEERRC (5631467,
     +   'DD range specification must follow DATTRIB statement')
        GO TO 90
      END IF

      IF (NDDTYP .EQ. 3 .OR. NDDTYP .GE. 7)  THEN
        CALL MEERRC (12845,
     +    'DD range: no range spec allowed for type H, C, and P')
        GO TO 90
      END IF

      CALL KADZZI (IFLAG)

      IF (NDDTYP .EQ. 1 .AND. IFLAG .LE. LDDEF_IUP)  GO TO 10
      IF (NDDTYP .EQ. 2 .AND. IFLAG .EQ. LDDEF_NBI)  GO TO 20
      IF (NDDTYP .EQ. 4 .AND.
     +  IFLAG .GE. LDDEF_FRA .AND. IFLAG .LE. LDDEF_FUP)  GO TO 40
      IF (NDDTYP .EQ. 5 .AND. IFLAG .LE. LDDEF_IUP)  GO TO 50
      IF (NDDTYP .EQ. 6 .AND. IFLAG .EQ. LDDEF_NBI)  GO TO 60
      CALL MEERRC (762354, 'DD range specification: wrong data type')
      GO TO 90

C integer
 10   IQ(L_L(JDDEF_RFLG,JDDEF)) = -ILARGEST
      IQ(L_L(JDDEF_DIV ,JDDEF)) =  ILARGEST
      IF (IFLAG .LE. LDDEF_ILO)  CALL KUGETI (IQ(L_L(JDDEF_RFLG,JDDEF)))
      IF (IFLAG .NE. LDDEF_ILO)  CALL KUGETI (IQ(L_L(JDDEF_DIV,JDDEF)))
      IF (IQ(L_L(JDDEF_DIV,JDDEF)) .LT. IQ(L_L(JDDEF_RFLG,JDDEF)))
     +   GO TO 80
      GO TO 90

C bit
 20   CALL KUGETI (IQ(L_L(JDDEF_RFLG,JDDEF)))
      IF (IQ(L_L(JDDEF_RFLG,JDDEF)) .LE. 0 .OR.
     +  IQ(L_L(JDDEF_RFLG,JDDEF)) .GT. 32)  GO TO 70
      GO TO 90

C float
 40   Q(L_L(JDDEF_FLO,JDDEF)) = -FLARGEST
      Q(L_L(JDDEF_FUP,JDDEF)) =  FLARGEST
      IF (IFLAG .LE. LDDEF_FLO)  CALL KUGETR (Q(L_L(JDDEF_FLO,JDDEF)))
      IF (IFLAG .NE. LDDEF_FLO)  CALL KUGETR (Q(L_L(JDDEF_FUP,JDDEF)))
      CALL KUGETR (Q(L_L(JDDEF_FAC,JDDEF)))
      IF (Q(L_L(JDDEF_FUP,JDDEF)) .LT. Q(L_L(JDDEF_FLO,JDDEF)))
     +   GO TO 80
      GO TO 90

C short
 50   IQ(L_L(JDDEF_RFLG,JDDEF)) = -SLARGEST
      IQ(L_L(JDDEF_DIV ,JDDEF)) =  SLARGEST
      IF (IFLAG .LE. LDDEF_ILO)  CALL KUGETI (IQ(L_L(JDDEF_RFLG,JDDEF)))
      IF (IFLAG .NE. LDDEF_ILO)  CALL KUGETI (IQ(L_L(JDDEF_DIV,JDDEF)))
      GO TO 90

C unsigned short
 60   CALL KUGETI (IQ(L_L(JDDEF_RFLG,JDDEF)))
      IF (IQ(L_L(JDDEF_RFLG,JDDEF)) .LE. 0 .OR.
     +  IQ(L_L(JDDEF_RFLG,JDDEF)) .GT. 16)  GO TO 70
      IF (IQ(L_L(JDDEF_DIV,JDDEF)) .LT. IQ(L_L(JDDEF_RFLG,JDDEF)))
     +   GO TO 80
      GO TO 90

 70   CALL LIDDE0 (NDDEF(), 'TL')
      CALL MEERRC (3456747,
     +  'DNBITS: 0 < number of bits <= 32 (unsigned short: 16) !!!')
      GO TO 90

 80   CALL LIDDE0 (NDDEF(), 'TL')
      CALL MEERRC (7613456,
     +  'DD range: error: upper < lower boundary')      

 90   END

************************************************************************
* End of KADRAN
************************************************************************
