*CMZ :  1.00/00 22/09/94  20.05.15  by  Fedor Ratnikov
*CMZ :   . 1/03 23/07/94  20.51.58  by  Dominik Ressing
*-- Author :    Dominik Ressing   23/07/94
************************************************************************
*
* L1PRCPO
* written by Dominik Ressing, 23/07/94 19.03.01
*
* This routines action:
* Returns the pointer to the processor description in L1PRCDF or 0 if
* processor is not defined. Range checking for input variables is
* performed !
* This works only after initialization (do not use before L1PRCIN
* was called).
* The pointers for type xxx are calculated by the statement
* function L1PCxxxp(iprc).
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* itype       in          one of the defined proc. types (in $L1PRCDF)
* iprc        in          processor number in L1PRCDF field L1PCstor !!
*
************************************************************************
c
      INTEGER FUNCTION L1PRCPO(itype,iprc)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1prcdf.fi"
c
      INTEGER itype,iprc
      LOGICAL L1PRCVA
      EXTERNAL L1PRCVA
#include "l1si/l1prcdf.ff"
c
      IF (itype.eq.L1PCtpre) THEN
         IF ( iprc.gt.0 .and. iprc.le.L1PARnpre ) THEN
            L1PRCPO = L1PCprep(iprc)
         ELSE
            L1PRCPO = 0
         END IF
      ELSEIF (itype.eq.L1PCttfu) THEN
         IF ( iprc.gt.0 .and. iprc.le.L1PARntfu ) THEN
            L1PRCPO = L1PCtfup(iprc)
         ELSE
            L1PRCPO = 0
         END IF
      ELSEIF (itype.eq.L1PCttpm) THEN
         IF ( iprc.gt.0 .and. iprc.le.L1PARntpm ) THEN
            L1PRCPO = L1PCtpmp(iprc)
         ELSE
            L1PRCPO = 0
         END IF
      ELSEIF (itype.eq.L1PCtmcu) THEN
         IF ( iprc.gt.0 .and. iprc.le.L1PARnmcu ) THEN
            L1PRCPO = L1PCmcup(iprc)
         ELSE
            L1PRCPO = 0
         END IF
      ELSE
         WRITE(L1LUNprn,*) ' L1PRCPO ==> undefined type :',itype
         L1PRCPO = 0
         RETURN
      END IF
c
      IF ( L1PCstor(L1PRCPO+L1PCnum).le.0 ) THEN ! processor defined ??
         L1PRCPO = 0
      END IF
c
      RETURN
c
      END
