*CMZ :          12/09/96  17.37.57  by  Fedor Ratnikov
*CMZ :  1.00/06 30/09/95  15.26.44  by   Ivan Belyaev
*CMZ :  1.00/03 11/09/95  12.07.47  by  Fedor Ratnikov
*CMZ :  1.00/02 20/08/95  15.09.38  by   Ivan Belyaev
*CMZ :  1.00/01 17/08/95  19.47.11  by   Ivan Belyaev
*CMZ :  1.00/00 15/02/95  23.38.20  by  Fedor Ratnikov
*CMZ :  0.01/03 17/09/94  15.17.43  by  Fedor Ratnikov
*-- Author :    Fedor Ratnikov   17/09/94
************************************************************************
*
* L1USRAC
* written by Fedor Ratnikov, 17/09/94 15.14.54
*
* This routines action:
* User routine colled from L1MCUACCEPT, that is when the event
* is accepted by FLT
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* iBX         in           events BX
* itrig       in           trigger type No
* MePo1,MePo2 in           pointers to pairs messages
* amass       in           invariant mass of pair
* bmass       in           invariant mass of pair including brems. correction
*
************************************************************************
c
      SUBROUTINE L1USRAC(iBX,itrig,MePo1,MePo2,amass,bmass)
c
      IMPLICIT NONE
c
#include "arte/Arte.fi"
#include "l1si/rcfdef.fi"
#include "l1si/ydef.fi"
#include "l1si/l1clink.fi"
#include "l1si/l1param.fi"
#include "l1si/l1banks.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1user.fi"
#include "l1si/l1mcuda.fi"
#include "l1si/rchead.fi"
c
      INTEGER iBX,itrig,MePo1,MePo2,itrak,iver,Jpo,itraorg,
     &        MePo,i,iPoPo
      integer iso,ipo,jj
      REAL    amass,bmass,
     &        Pt,Kt,CGx,CGy,emi,ema,pOe1,pOe2
      LOGICAL HEXIST
      REAL ZmaxORG
      PARAMETER (ZmaxORG=650.)    ! Maximal Z for origin particle
c
      INTEGER  IDpre,IDorg,IDtra,nSelfPo,iRpo,iSpo
      REAL     pmcpre,pmctra,vzpre,Easym
      CHARACTER*4 cName
      COMMON /L1CUSRAC/ IDpre,IDorg,IDtra,nSelfPo,iSpo,
     &     iRpo,pmcpre,pmctra,vzpre
c
#include "arte/Arte.ff"
#include "l1si/rcfunc.ff"
#include "l1si/ydef.ff"
#include "l1si/l1mesdf.ff"
c
c
      L1MASTUbx    = iRCEvent
      L1MASTUnInt  = nRCIntTot
      T1MASTUEinner= T1EVEinner(iBX)
      L1MASTUType1 = L1MEstor(MePo1+L1MEpartID)
      T1MASTUP1    = T1MEstor(MePo1+L1MEp)
      T1MASTUPx1   = T1MEstor(MePo1+L1MEpx)
      T1MASTUPy1   = T1MEstor(MePo1+L1MEpy)
      T1MASTUPz1   = T1MEstor(MePo1+L1MEpz)
      T1MASTUEpre1 = T1MEstor(MePo1+L1MEpren)
      T1MASTUKTrig1= T1MEstor(MePo1+L1MEprth)*T1DEFktrig
      T1MASTUcogx1 = MIN(T1MEstor(MePo1+L1POlcogFactorX),4.)
      T1MASTUcogy1 = MIN(T1MEstor(MePo1+L1POlcogFactorY),4.)
      T1MASTUEbre1 = T1MEstor(MePo1+L1MEpren)*
     &     T1MEstor(MePo1+L1MEBremRatio)
      IF ( L1MEstor(MePo1+L1MEcharge).ge.0 ) THEN
         T1MASTUThBre1 = T1MEstor(MePo1+L1MEBremPlusTh)
      ELSE
         T1MASTUThBre1 = T1MEstor(MePo1+L1MEBremMinusTh)
      END IF
      L1MASTUType2 = L1MEstor(MePo2+L1MEpartID)
      T1MASTUP2    = T1MEstor(MePo2+L1MEp)
      T1MASTUPx2   = T1MEstor(MePo2+L1MEpx)
      T1MASTUPy2   = T1MEstor(MePo2+L1MEpy)
      T1MASTUPz2   = T1MEstor(MePo2+L1MEpz)
      T1MASTUEpre2 = T1MEstor(MePo2+L1MEpren)
      T1MASTUKTrig2= T1MEstor(MePo2+L1MEprth)*T1DEFktrig
      T1MASTUcogx2 = MIN(T1MEstor(MePo2+L1POlcogFactorX),4.)
      T1MASTUcogy2 = MIN(T1MEstor(MePo2+L1POlcogFactorY),4.)
      T1MASTUEbre2 = T1MEstor(MePo2+L1MEpren)*
     &     T1MEstor(MePo2+L1MEBremRatio)
      IF ( L1MEstor(MePo2+L1MEcharge).ge.0 ) THEN
         T1MASTUThBre2 = T1MEstor(MePo2+L1MEBremPlusTh)
      ELSE
         T1MASTUThBre2 = T1MEstor(MePo2+L1MEBremMinusTh)
      END IF

      T1MASTUMassA = amass
      T1MASTUMassB = bmass
c
      iPoPo = MePo1+L1MEpoint(0)+L1POreg
      T1MASTUXpre1 = T1MEstor(iPoPo+L1GEOINFx0)+
     &      0.5*T1MEstor(iPoPo+L1GEOINFsx)
      T1MASTUYpre1 = T1MEstor(iPoPo+L1GEOINFy0)+
     &      0.5*T1MEstor(iPoPo+L1GEOINFsy)
      iPoPo = MePo2+L1MEpoint(0)+L1POreg
      T1MASTUXpre2 = T1MEstor(iPoPo+L1GEOINFx0)+
     &      0.5*T1MEstor(iPoPo+L1GEOINFsx)
      T1MASTUYpre2 = T1MEstor(iPoPo+L1GEOINFy0)+
     &      0.5*T1MEstor(iPoPo+L1GEOINFsy)



      IF( L1MASTUType1 .EQ. L1MCUpiplus
     &                 .OR.
     &    L1MASTUType1 .EQ. L1MCUpiminus ) THEN
       T1MASPTTUP1PTx  = T1MEstor( MePo1 + L1MEpreXpt  )
       T1MASPTTUP1PTdx = T1MEstor( MePo1 + L1MEpreDXpt )
       T1MASPTTUP1PTz  = T1MEstor( Mepo1 + L1MEpreZpt  )
      ELSE
       T1MASPTTUP1PTx  = 0.0
       T1MASPTTUP1PTdx = 0.0
       T1MASPTTUP1PTz  = 100.0
      ENDIF
      IF( L1MASTUType2 .EQ. L1MCUpiplus
     &                 .OR.
     &    L1MASTUType2 .EQ. L1MCUpiminus ) THEN
       T1MASPTTUP2PTx  = T1MEstor( MePo2 + L1MEpreXpt  )
       T1MASPTTUP2PTdx = T1MEstor( MePo2 + L1MEpreDXpt )
       T1MASPTTUP2PTz  = T1MEstor( Mepo2 + L1MEpreZpt  )
      ELSE
       T1MASPTTUP2PTx  = 0.0
       T1MASPTTUP2PTdx = 0.0
       T1MASPTTUP2PTz  = 100.0
      ENDIF
      T1MASPTTUEnergyAsymmetry =
     & ( T1MASTUP1 - T1MASTUP2 ) /
     & ( T1MASTUP1 + T1MASTUP2 )
c
c     Fill MC matching data
c
      DO i=1,2
       IF(i.EQ.1) THEN
        MePo = MePo1
       ELSE
        MePo = MePo2
       ENDIF
       itrak = L1MEstor(MePo+L1MEpretrk)
       IF(itrak.GT.0)    THEN
        CALL l1cpart(OMTRA_TOPP(itrak),IDpre,cname) ! GEANT id
        iver = IMTRA_ORIG(itrak)
        pmcpre = SQRT(FMTRA_PX(itrak)**2+
     &       FMTRA_PY(itrak)**2+FMTRA_PZ(itrak)**2)
c       look for real vertex
 110    CONTINUE
        IF(iver.EQ.0)   THEN    ! main vertex?
         vzpre = 0.
        ELSEIF(iver.LT.0)  THEN ! parent track
         iver = IMTRA_ORIG(-iver)
         GOTO 110               ! try parent
        ENDIF
        IF(iver.NE.0)  THEN     ! vertex
         vzpre = FMVER_Z(iver)
        ELSE
         vzpre = 0.
        ENDIF
 100    CONTINUE
        itraorg = OMVER_BTRA(iver) ! origin track
        IF(itraorg.GT.0)    THEN
         CALL l1cpart(OMTRA_TOPP(itraorg),IDorg,cname) ! GEANT id
        ELSE
         IDorg = 0
        ENDIF
       ELSE                     ! No MC matching found
        IDpre = 0
        vzpre = 0.
        IDorg = 0
        pmcpre = 0.
       ENDIF
       itrak = L1MEstor(MePo+L1MEtrktrk)
       IF(itrak.GT.0)    THEN
        CALL l1cpart(OMTRA_TOPP(itrak),IDtra,cname) ! GEANT id
        pmctra = SQRT(FMTRA_PX(itrak)**2+
     &       FMTRA_PY(itrak)**2+FMTRA_PZ(itrak)**2)
       ELSE                     ! No MC matching found
        IDtra = 0
        pmcpre = 0.
       ENDIF
       nSelfPo = L1MEstor(MePo+L1MEghost)
       iSpo = L1MEstor(MePo+L1MEselfP)
       iRpo = L1MEstor(MePo+L1MErealP)
       IF(i.EQ.1)   THEN
        CALL UCOPY(IDpre,L1MASMCIDpre1,9)
       ELSE
        CALL UCOPY(IDpre,L1MASMCIDpre2,9)
       ENDIF
      ENDDO
c
      IF(HEXIST(L1MASTUPnr))
     &     CALL HFNT(L1MASTUPnr)
c
c      IF(HEXIST(L1MASMCTUPnr))
c     &     CALL HFNT(L1MASMCTUPnr)
c
c
      Pt   = MIN(sqrt(T1MASTUPx1**2+T1MASTUPy1**2),
     &       sqrt(T1MASTUPx2**2+T1MASTUPy2**2))
      Kt   = MIN(T1MASTUKTrig1,T1MASTUKTrig2)
      CGx  = MAX(T1MEstor(MePo1+L1POlcogFactorX),
     &         T1MEstor(MePo2+L1POlcogFactorX))
      CGy  = MAX(T1MEstor(MePo1+L1POlcogFactorY),
     &         T1MEstor(MePo2+L1POlcogFactorY))
      pOe1 = T1MASTUP1/T1MASTUEpre1
      pOe2 = T1MASTUP2/T1MASTUEpre2
      emi  = MIN(T1MASTUP1,T1MASTUP2)
      ema  = MAX(T1MASTUP1,T1MASTUP2)
      Easym = ABS( ( T1MASTUP1 - T1MASTUP2 ) /
     &             ( T1MASTUP1 + T1MASTUP2 ) )
c
c
c    --- are user cuts exceeded ????
c
      IF(    ( ( L1MASTUType1 .EQ. L1MCUeplus  ) .OR.
     &         ( L1MASTUType1 .EQ. L1MCUeminus ) )
     & .AND. ( ( L1MASTUType2 .EQ. L1MCUeplus  ) .OR.
     &         ( L1MASTUType2 .EQ. L1MCUeminus ) ) ) THEN
       IF ( Pt .gt.T1USRCUTPt       .and.
     &      MIN(pOe1,pOe2).gt.T1USRCUTEpOeMin  .and.
     &      MAX(pOe1,pOe2).lt.T1USRCUTEpOeMax  .and.
     &      emi.gt.T1USRCUTEmin     .and.
     &      ema.lt.T1USRCUTEmax     .and.
     &      T1MASTUEinner.lt.T1USRCUTEin  .and.
     &      bmass.lt.T1USRCUTMmax   .and.
     &      bmass.gt.T1USRCUTMmin ) THEN
        IF ( ABS(amass-3.1).lt.ABS(T1EVMAXMass(iBX)-3.1)) THEN
         T1EVMAXMass(iBX)   = amass
         T1EVMAXPtSe(iBX)   = 0.
         T1EVMAXPtSm(iBX)   = 0.
         T1EVMAXPtUee(iBX)  = 0.
         T1EVMAXPtee(iBX)   = 0.
         T1EVMAXPtUmm(iBX)  = 0.
         T1EVMAXFbrems(iBX) = bmass/amass
        END IF
        L1EVMAXnpairs(iBX) = L1EVMAXnpairs(iBX)+1
c
c        --- fill output message pair into zebra bank
c
        iso = MePo1+L1HAprbx
        DO jj=1,2
c
         IF ( N_F(JL1_HAMESS).le.0 ) THEN         ! space in table ?
          CALL UTETAB(IXDIV,JL1_HAMESS,20)      ! EXPAND TABLE

          IF ( N_F(JL1_HAMESS).le.0 ) THEN      ! expand successfull ?
           WRITE(L1LUNprn,*)
     &      'L1USRAC ==> no table storage',
     &      N_F(JL1_HAMESS)
            GO TO 889
          END IF
         END IF
c
         IQ(JL1_HAMESS+2) = IQ(JL1_HAMESS+2) + 1   ! add on row in table
         ipo              = L_L(1,JL1_HAMESS)      ! point to new row
         DO i=1,L1_HAMES_LEN                       ! copy message data
          IQ(ipo) = L1MEstor(iso)
          ipo = ipo + 1
          iso = iso + 1
         END DO
         iso = MePo2+L1HAprbx
c
        END DO
c
 889    CONTINUE
c
       END IF
      ELSE
C*
C*     No additional User cuts for other triggers
C*
        IF ( ABS(amass-5.28).lt.ABS(T1EVMAXMass(iBX)-5.28)) THEN
         T1EVMAXMass(iBX)   = amass
         T1EVMAXPtSe(iBX)   = 0.
         T1EVMAXPtSm(iBX)   = 0.
         T1EVMAXPtUee(iBX)  = 0.
         T1EVMAXPtee(iBX)   = 0.
         T1EVMAXPtUmm(iBX)  = 0.
         T1EVMAXFbrems(iBX) = bmass/amass
        END IF
        L1EVMAXnpairs(iBX) = L1EVMAXnpairs(iBX)+1
c
c        --- fill output message pair into zebra bank
c
        iso = MePo1+L1HAprbx
        DO jj=1,2
c
         IF ( N_F(JL1_HAMESS).le.0 ) THEN         ! space in table ?
          CALL UTETAB(IXDIV,JL1_HAMESS,20)      ! EXPAND TABLE

          IF ( N_F(JL1_HAMESS).le.0 ) THEN      ! expand successfull ?
           WRITE(L1LUNprn,*)
     &      'L1USRAC ==> no table storage',
     &      N_F(JL1_HAMESS)
            GO TO 888
          END IF
         END IF
c
         IQ(JL1_HAMESS+2) = IQ(JL1_HAMESS+2) + 1   ! add on row in table
         ipo              = L_L(1,JL1_HAMESS)      ! point to new row
         DO i=1,L1_HAMES_LEN                       ! copy message data
          IQ(ipo) = L1MEstor(iso)
          ipo = ipo + 1
          iso = iso + 1
         END DO
         iso = MePo2+L1HAprbx
c
        END DO
c
 888    CONTINUE
c
      ENDIF
c
c
      RETURN
c
      END

