
// *****************************************************************************
//
// source:    l4tEvnt.C
//
// type:      source code
//
// created:   14 Jan 1998
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    l4tEvnt
//
// hint:      
//
// changes:
// 25 Nov 1999 (AG) move to l4tEvnt()
// 22 Feb 2000 (AG) handle various settings
// 13 Mar 2000 (AG) remove some printout
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// Arte includes
#include "arte/arte.hh"
#include "arte/ArteUtil.h"
#include "l4trig/l4t.hh"

// externals
extern int FATRG;

//
// program code
//
int
l4tEvnt()
{
  // counters
  static int nAll = 0;
  static int nDST = 0;
  static int nOUT = 0;

  // EVHD table
  ArtePointer<EVHD> evhd( 1 );
  //evhd->flagdst = 1;
  //cout << "l4tEvnt(): evhd->flagdst=" << evhd->flagdst << endl;

  // output flag
  //cout << "l4tEvnt(): FATRG=" << FATRG << endl;
  switch( FATRG ){
  case L4_OFF:
    arteutil_.eventout = 1;
    break;
  case L4_ON:
    arteutil_.eventout = evhd->flagdst;
    break;
  case L4_KEEP:
    arteutil_.eventout = 1;
    break;
  case L4_REJECT:
    arteutil_.eventout = 0;
    break;
  default:
    arteutil_.eventout = 1;
  }

  cout << " TRIGGER: "
       << "TRG=" << FATRG              << " "
       << "DST=" << evhd->flagdst      << " "
       << "OUT=" << arteutil_.eventout << endl;

  // statistics
  nAll++;
  if( evhd->flagdst )      nDST++;
  if( arteutil_.eventout ) nOUT++;
  cout << " TRIGGER: Summary: "
       << "ALL=" << nAll << " "
       << "DST=" << nDST << " "
       << "OUT=" << nOUT << endl;

  return 0;
}
