//**********************************************************************/
// Created: 23.08.97,   Olya Igonkina   for   MARPLE package
//
// implementation of RcHitBPoint class
//
//**********************************************************************/
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"

#include "marple/marple.hh"
#include "marple/RcHitBPoint.hh"

// returns relation with MTRA 
std::vector<ArtePointer<MTRA> > RcHitBPoint::mtraList() const
{
  std::vector<ArtePointer<MTRA> > mList;
  if( ArteTable<MTRA>::size() == 0 ) return mList;
  for( ArteRelationIterator<MIMP>   rsMimp = link()->mimp.begin();
       rsMimp != link()->mimp.end();
       ++rsMimp )
    {
      mList.push_back((*rsMimp)->mtra);
    }
  return mList;
}

// returns relation with HITB 
std::vector<ArtePointer<HITB> > RcHitBPoint::hitbList() const
{
  std::vector<ArtePointer<HITB> > hList;
  hList.push_back( link() );
  return hList;
}

// no Kalman refit of RcHitBPoint implemented. dummy function
HepDouble RcHitBPoint::refitAll(int & iErr)
{ iErr = 0; return 0; }

// no Kalman refit of RcHitBPoint implemented. dummy function
HepDouble RcHitBPoint::refitForward(int & iErr)
{ iErr = 0; return 0; }

// no Kalman refit of RcHitBPoint implemented. dummy function
HepDouble RcHitBPoint::refitBack(int & iErr)
{ iErr = 0; return 0; }

ostream & operator << (ostream & os, const RcHitBPoint &rp)
{
  const RcPoint * ptPoint = &rp;
  os << *ptPoint;
  os << "            HITB link: " << rp.link() << endl ;
  return os ;
}
