
//## Boris Fominykh  27.12.1999
// member functions of class MuDbTube

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

#include "murec/MuDbTube.h"

extern "C" {
int MuNameDecode(char*,int*,int*,int*,int*,int*,int*);
}

//** Constructor */
MuDbTube::MuDbTube()
{
  Ivalid=-1;
  Clear();
}

//** Destructor */
MuDbTube::~MuDbTube()
{
}

//## Methods

void MuDbTube::Clear()
{
  for(Word sl=0; sl<TubeGeoSl; sl++) {
    for(Word lay=0; lay<TubeGeoLay; lay++) {
      for(Word ud=0; ud<TubeGeoUpDown; ud++) {
        NchambT[sl][lay][ud] = 0;
        for(Word nx=0; nx<TubeGeoNx; nx++) {
          char* name = "        ";
          strncpy(&ChamListT[sl][lay][ud][nx][0],name,9);
          TubeGede[sl][lay][ud][nx][0] = 0;
          TubeGede[sl][lay][ud][nx][1] = 0;
          NconnT[sl][lay][ud][nx]=0;
          CrateT[sl][lay][ud][nx]=0;
          StepT[sl][lay][ud][nx] =0;
          for(Word nc=0; nc<Nconn; nc++) {
            for(Word sd=0; sd<TubeGeoSd; sd++) {
              Wire1T[sl][lay][ud][nx][nc][sd]=0;
              Nbit1T[sl][lay][ud][nx][nc][sd]=0;
            }
          }
        }
      }
    }
  }
}

int MuDbTube::SetStruct()
{
  int ret;
// NESL objects
  MuNesl   lnesl;  
  MuDbNesl Nesl;  
  Nesl.setDBname(DBname);
  Nesl.setKTstatus(-2);
  Nesl.setRun(Run);
  Nesl.setMinor(Minor);
  ret=Nesl.Read();
  if(ret != 0) {
    arteMsg << "MuDbTube: NESL table is NOT read ret= " << ret;;
    arteMsg << " DBname= " << DBname << " Run= " << Run;
    arteMsg << " Minor " << Minor << endl;
    arteMsg.warn();
    return 10+ret;
  }

// NEDE objects
  MuNede   lnede;  
  MuDbNede Nede;  
  Nede.setDBname(DBname);
  Nede.setKTstatus(-2);
  Nede.setRun(Run);
  Nede.setMinor(Minor);
  ret=Nede.Read();
  if(ret != 0) {
    arteMsg << "MuDbTube: NEDE table is NOT read ret= " << ret;;
    arteMsg << " DBname= " << DBname << " Run= " << Run;
    arteMsg << " Minor " << Minor << endl;
    arteMsg.warn();
    return 20+ret;
  }

// loops over superlayers MU1, MU2
  for(int sl=0; sl<2; sl++) {
// superlayer key
    int neslkey = 10*sl+18;
// read the superlayer information from DB
    ret=Nesl.Get(&neslkey,&lnesl);
    if(ret != 0) return 30+ret;
    else {
      int cmp = lnesl.cmp;
      int laym = lnesl.lay;
      if(cmp == 8 && laym > 0) {
// loops over layers
        for(int l=0; l<laym; l++) {
// loops over UpDown
          for(int ud=0; ud<2; ud++) {
            NchambT[sl][l][ud]=lnesl.chamb[2*l+ud]+lnesl.nx99[2*l+ud];
          }
        }
// cross-check
        int nvol=lnesl.npl;
        int nvl=0;
        for(int l=0; l<laym; l++) {
          for(int ud=0; ud<2; ud++) {
            nvl+=2*NchambT[sl][l][ud];
          }
        }
        if(nvl != nvol) {
          arteMsg << "cross-check: nvol " << nvol << " nvl " << nvl << endl;
          arteMsg.warn();
        }
// loops over nede elements
        for(int lay=0; lay<laym; lay++) {
          for(int ud=0; ud<2; ud++) {
            if(NchambT[sl][lay][ud] > 0) {
              for(int nx=0; nx<NchambT[sl][lay][ud]; nx++) {
                int nxx=0;
                if(nx < lnesl.chamb[2*lay+ud]) nxx=nx+1;
                if(nx == lnesl.chamb[2*lay+ud] && lnesl.nx99[2*lay+ud] == 1) nxx=99;
                if(nxx > 0) {
                  for(int sd=0; sd<2; sd++) {
// key word of NEDE element
  int nedekey = 100000*(sl+1)+10000*(lay+1)+1000*ud+10*nxx+sd;
                    ret=Nede.Get(&nedekey,&lnede);
                    if(ret != 0) {
		      arteMsg << "MuDbTube: no NEDE for key " << nedekey << endl;
                      arteMsg.warn();
                    }
                    else {
                      TubeGeoWire=lnede.nwi[0];
                      TubeGede[sl][lay][ud][nx][sd]=lnede.inede;
                      strncpy(&(ChamListT[sl][lay][ud][nx][0]),&(lnede.hwc[0]),9);
                      ChamListT[sl][lay][ud][nx][8]='\0';
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  Nesl.Release();
  Nede.Release();
  return 0;
}

int MuDbTube::SetConnect()
{
  int ret=0;
  int NcabR=0;
// Config object
  MuDbConfig Conf;
  Conf.setDBname(DBname);
  Conf.setKTstatus(KTstatus);
  Conf.setRun(Run);
  Conf.setMinor(Minor);
  ret=Conf.Read(&NcabR);
  if(ret != 0 || NcabR <= 0) {
    arteMsg << "MuDbTube: cable configuration table is NOT read, ret= " << ret;
    arteMsg << " NcabR= " << NcabR << " DBname= " << DBname << " Run= " << Run;
    arteMsg << " Minor " << Minor << endl;
    arteMsg.warn();
    return 10+ret;
  }
// hot channel object
  MuDbHots Hots;
  Hots.setDBname(DBname);
  Hots.setKTstatus(KTstatus);
  Hots.setRun(Run);
  Hots.setMinor(Minor);
  ret=Hots.Read();
  if(ret != 0) {
    arteMsg << "MuDbTube: hot channel table is NOT read, ret= " << ret;
    arteMsg << " DBname= " << DBname << " Run= " << Run;
    arteMsg << " Minor " << Minor << endl;
    arteMsg.warn();
    return 20+ret;
  }
// loops over cables
  for(int ncb=0; ncb<NcabR; ncb++) {
    char name[10];
    Word crate=0;
    Word ncabl=0;
// get the next cable connection
    ret=Conf.GetCabl(&ncb,name,&crate,&ncabl);
    if(ret != 0) return 30+ret;
// decode the cable name
    int type = 0;
    int msl  = 0;
    int lay  = 0;
    int ud   = 0;
    int nx   = 0;
    int ncab = 0;
    ret=MuNameDecode(&name[0],&type,&msl,&lay,&ud,&nx,&ncab);
    if(type == 1) {
      int sl=msl-1;
      lay-=1;
      nx-=1;
      ncab-=1;
// get the cable hot channel mask
      Word status=Hots.Status(name);
// cable bit position inside crate
      Word nbit = 16*ncabl; 
// the special case of chamber 99
      if(ud == 1 && nx == 98) nx=NchambT[sl][lay][ud]-1;         
      if(nx > NchambT[sl][lay][ud]-1 || nx < 0) {
        arteMsg << "MuDbTube: wrong nx = " << nx << " ncb " << ncb << endl;
        arteMsg.warn();
        continue;
      }

//      cout << "MuDbTube: ncb= " << dec << ncb << " " << name;
//      cout << " ret " << ret << " type: " << type;
//      cout << " msl: " << msl << " lay: " << lay;
//      cout << " ud: " << ud << " nx: " << nx;
//      cout << " ncab: " << ncab << " mask " << hex << status;
//      cout << dec << endl;

      int nc = NconnT[sl][lay][ud][nx];
      NconnT[sl][lay][ud][nx] += 1;
      MaskT[sl][lay][ud][nx][nc] = status;
      if(ud == 0) {
        StepT[sl][lay][ud][nx] =-2;
        StepT[sl][lay][ud][nx] =-2;
 
        CrateT[sl][lay][ud][nx]       =crate;
        Nbit1T[sl][lay][ud][nx][nc][0]=nbit+1;
        Nbit1T[sl][lay][ud][nx][nc][1]=nbit;
 
        if(ncab == 0) {
          Wire1T[sl][lay][ud][nx][nc][0]=15;
          Wire1T[sl][lay][ud][nx][nc][1]=15;
        }
        if(ncab == 1) {
          Wire1T[sl][lay][ud][nx][nc][0]=7;
          Wire1T[sl][lay][ud][nx][nc][1]=7;
        }
      }
      if(ud == 1) {
        StepT[sl][lay][ud][nx] =2;
        StepT[sl][lay][ud][nx] =2;
 
        CrateT[sl][lay][ud][nx]       =crate;
        Nbit1T[sl][lay][ud][nx][nc][0]=nbit;
        Nbit1T[sl][lay][ud][nx][nc][1]=nbit+1;
 
        if(ncab == 0) {
          Wire1T[sl][lay][ud][nx][nc][0]=0;
          Wire1T[sl][lay][ud][nx][nc][1]=0;
        }
        if(ncab == 1) {
          Wire1T[sl][lay][ud][nx][nc][0]=8;
          Wire1T[sl][lay][ud][nx][nc][1]=8;
        }
      }
    }
  }

  Hots.Release();
  Conf.Release();
  return 0;
}

int MuDbTube::Ini()
{
  Ivalid=-1;
  Clear();
  int ret = 0;
  ret=MuDbTube::SetStruct();
  if(ret != 0) return ret+10;
  ret=MuDbTube::SetConnect();
  if(ret != 0) return ret+20;
  Ivalid=1;
  return 0;
}

void MuDbTube::Print()
{
// create the log-file and pipe the programm output
  ofstream fout("MuDbTube.out");
  if (!fout) {
    arteMsg << "MuDbTube - can NOTt open file for print" << endl;
    arteMsg.warn();
    return;
  }

  fout << "MuDbTube: Ivalid= " << Ivalid << endl;
  for(Word sl=0; sl<TubeGeoSl; sl++) {
    for(Word lay=0; lay<TubeGeoLay; lay++) {
      for(Word ud=0; ud<TubeGeoUpDown; ud++) {
        fout << "tube chamber sl " << dec << sl << " lay " << lay;
        fout << " UpDown " << ud << " Nchamb " << NchambT[sl][lay][ud] << endl; 
        if(NchambT[sl][lay][ud] > 0) {
          for(Word nx=0; nx<NchambT[sl][lay][ud]; nx++) {
            char name[9];
            strncpy(name,&ChamListT[sl][lay][ud][nx][0],9);
            fout << name << " nx " << nx;
            fout << " Ncable " << NconnT[sl][lay][ud][nx] << endl;
            if(NconnT[sl][lay][ud][nx] > 0) {
              for(Word nc=0; nc<NconnT[sl][lay][ud][nx]; nc++) {
                for(Word sd=0; sd<TubeGeoSd; sd++) {
                  fout << "   #cable " << nc;
                  fout << " mask " << hex << MaskT[sl][lay][ud][nx][nc];
                  fout << " side " << dec << sd;
                  fout << " wire1 " << dec << Wire1T[sl][lay][ud][nx][nc][sd];
                  fout << " crate " << hex << CrateT[sl][lay][ud][nx];
                  fout << " Nbit1 " << dec << Nbit1T[sl][lay][ud][nx][nc][sd];
                  Word word = Nbit1T[sl][lay][ud][nx][nc][sd] / 32;
                  Word bit  = Nbit1T[sl][lay][ud][nx][nc][sd] - word*32;
                  fout << " (" << word << "-" << bit << ") ";
                  fout << " step " << dec << StepT[sl][lay][ud][nx];
                  fout << " gede " << dec << TubeGede[sl][lay][ud][nx][sd];
                  fout << endl;
                }
              }
            }
          }
        }
      }
    }
  }
}
