#ifndef MuDbAlign_h
#define MuDbAlign_h 1

//## Class: MuDbAlign
//      /**Author:        Boris Fominykh
//
//      Date:             December 23, 1999
//
//      Class:            MuDbAlign
//
//      Base Class:       MuDbTable
//
//      Description:
//      This class is for operations with alignment constants in muon DB*/

#include "murec/MuDbTable.h"
#include "murec/MuAlign.h"

class MuDbAlign : public MuDbTable
{
  public:
    //## Constructor
           MuDbAlign();
    //## Destructor
           ~MuDbAlign();

    //public methods
      //        /**Create the table of alignment constants in DB from ascii-file*/
      int Create();
      //        /**Read the table from DB into temporary space*/
      int Read();
      //        /**Read the table from ascii-file into temporary space*/
      int ReadFile();
      //        /**Print the alignment constants from temporary space*/
      void Print();
      //        /**Get the alignment constants for frame*/
      int Get(int* frame, MuAlign* const);
      //        /**release the temporary space*/
      void Release();

    //## Get and Set Operations for Class Attributes
      //        /**Set the number of frames*/
      void setNframe(int nframe);
      //        /**Get the number of frames*/
      int getNframe();


  protected:

      int Nframe;

  private:

    static const int NelInt   = 21;
    static const int NelFloat = 6;
      int    Status;
      int    Ncollect;
      int    SizeW;
      int*   ElIntW;
      float* ElFlW;

    //        /**Initialization*/
      void Ini();
    //        /** Book the temporary space */
      int Book();
    //        /**Add the next table line to temporary space*/
      int Add(MuAlign* const);
    //        /**Write the table from temporary space to DB*/
      int Write();
};


//## Get and Set Operations for Class Attributes (inline)
     inline void MuDbAlign::setNframe(int nframe)
{
  Nframe=nframe;
}

     inline int MuDbAlign::getNframe()
{
  return Nframe;
}

#endif

