#ifndef MuDbChamber_h
#define MuDbChamber_h 1

//## Class: MuDbChamber
//      /**Author:        Boris Fominykh
//
//      Date:             December 26, 1999
//
//      Class:            MuDbChamber
//
//      Base Class:       none
//
//      Description:
//      This class is a base class for configuration of muon chambers*/

class MuDbChamber
{
  public:
    //## Constructor
           MuDbChamber();
    //## Destructor
           ~MuDbChamber();

    //public methods

    //## Get and Set Operations for Class Attributes
      void setDBname(char* name);
      void setKTstatus(int value);
      int  getKTstatus();
      void setRun(int value);
      int  getRun();
      void setMinor(int value);
      int  getMinor();
      void setEndian();
      int  getEndian();

  protected:

    char DBname[256];
    int KTstatus;
    int Run;
    int Minor;
    int Endian;

  private:

};

//## Get and Set Operations for Class Attributes (inline)

inline void MuDbChamber::setKTstatus(int value)
{
  KTstatus=value;
}

inline int MuDbChamber::getKTstatus()
{
  return KTstatus;
}

inline void MuDbChamber::setRun(int value)
{
  Run=value;
}

inline int MuDbChamber::getRun()
{
  return Run;
}

inline void MuDbChamber::setMinor(int value)
{
  Minor=value;
}

inline int MuDbChamber::getMinor()
{
  return Minor;
}

inline int MuDbChamber::getEndian()
{
  return Endian;
}

#endif
