*
* B.Fominykh  07.08.97
*
* test the quality of reconstructed track
* input:  NT    - reco track number
* output: IQUAL - =0 track accepted, <0 track rejected
*         RQUAL - quality parameter
*
      SUBROUTINE MURTTR(NT,IQUAL,RQUAL)
*     =================================
      IMPLICIT NONE
#include "arte/Arte.fi"
#include "murec/MUCTAB.fi"
      INTEGER IQUAL,NT,JT,I,J,ICC,IC,JC,MUSL,LAY,RLAY,ITYPE
      INTEGER HITMAP(4,4),RCL(38),HT,HTM
      REAL Z0,CX,CY,TX,TY,DD,D(38),RQUAL
#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
      IQUAL=-1
      IF(NT.LE.0.OR.NT.GT.IQ(JTMP7+2)) GOTO 999
      JT=JTMP7+IQ(JTMP7+1)*(NT-1)+2
* number of accepted clusters
      IF(IQ(JT+3).LT.3) GOTO 999
* tx, ty control
      IF(ABS(Q(JT+8)).GT.0.5) GOTO 999
      IF(ABS(Q(JT+9)).GT.0.5) GOTO 999
*
      DO I=1,38
        RCL(I)=0
        D(I)  =0.
      ENDDO
      DO I=1,4
       DO J=1,4
        HITMAP(I,J)=0
       ENDDO
      ENDDO
* fill hitmap - loops over collected clusters
* the cut on residuals is apllied
      Z0=Q(JT+5)
      CX=Q(JT+6)
      CY=Q(JT+7)
      TX=Q(JT+8)
      TY=Q(JT+9)
      DO 10 ICC=1,IQ(JT+3)
        IC=IQ(JT+LCMUTR+ICC)
        JC=JTMP8+IQ(JTMP8+1)*(IC-1)+2
        RLAY=IQ(JC+2)
        MUSL=IQ(JC+3)
        LAY =IQ(JC+4)
        ITYPE=IQ(JC+5)
        RCL(RLAY)=1
        IF(ITYPE.EQ.1) D(RLAY)=Q(JC+8)
        HITMAP(MUSL,LAY)=1
  10  CONTINUE

* number of MU1,MU2 hits, pixels have the weight 3.
       RQUAL=3.*REAL(HITMAP(1,4))+
     +       REAL(HITMAP(1,1)+HITMAP(1,2)+HITMAP(1,3))+
     +       3.*REAL(HITMAP(2,4))+
     +       REAL(HITMAP(2,1)+HITMAP(2,2)+HITMAP(2,3))
* 
* increase the weight if there are hits in both sides 
* MU1
       DO I=1,4
         IF(RCL(2*I-1)+RCL(2*I).EQ.1) RQUAL=RQUAL-3.
         IF(RCL(2*I-1)+RCL(2*I).EQ.2) THEN
           DD=ABS(D(2*I-1)-D(2*I))
           IF(DD.GT.2.) RQUAL=RQUAL-2.
         ENDIF
       ENDDO
* MU2
       DO I=6,8
         IF(RCL(2*I-1)+RCL(2*I).EQ.1) RQUAL=RQUAL-3.
         IF(RCL(2*I-1)+RCL(2*I).EQ.2) THEN
           DD=ABS(D(2*I-1)-D(2*I))
           IF(DD.GT.2.) RQUAL=RQUAL-2.
         ENDIF
       ENDDO

* topology control
* pixel tracks
      IF(HITMAP(1,4).GE.1.AND.HITMAP(3,2).GE.1.AND.
     +                        HITMAP(4,2).GE.1) GOTO 24
*   MU1
      IF(HITMAP(1,4).GE.1) GOTO 21
      HTM=HITMAP(1,1)+HITMAP(1,2)+HITMAP(1,3)
      HT = 0
      DO I=1,8
        HT = HT+RCL(I)
      ENDDO
      IF(HTM.GE.3.AND.HT.GE.3) GOTO 21 
      GOTO 999
 21   CONTINUE
*   MU2
      IF(HITMAP(2,4).GE.1) GOTO 22
      HTM=HITMAP(2,1)+HITMAP(2,2)+HITMAP(2,3)
      HT = 0
      DO I=11,16
        HT = HT+RCL(I)
      ENDDO
      IF(HTM.GE.3.AND.HT.GE.3) GOTO 22 
      GOTO 999
 22   CONTINUE
*   MU3
      IF(HITMAP(3,2).GE.1) GOTO 23
      HT = 0
      HT = RCL(19)+RCL(22)+RCL(23)+RCL(26)
      IF(HT.LT.1) GOTO 999
 23   CONTINUE
*   MU4
      IF(HITMAP(4,2).GE.1) GOTO 24
      IF(RCL(29)+RCL(32)+RCL(33)+RCL(36).LT.1) GOTO 999
      HT = HT+RCL(29)+RCL(32)+RCL(33)+RCL(36)
      IF(HT.LT.3) GOTO 999
 24   CONTINUE
      IQUAL=0
*
 999  CONTINUE
      RETURN
      END









