      subroutine dilay
*********************************************************
*
* Displays GEDE volumes with color according to sector
* 
* Parameters read from KUIP:
*   SL     - superlayer name
*   lay    - stereolayer
*
* Author: Alexander Lanyov   Mar 99
*
*********************************************************
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "pris/zgraf.fi"

      integer lay,l,slnamh,pl,pl1,pl2,isl,kwkid
      character slnam*4
      logical first
      data first /.true./

#include "arte/Arte.ff"
#include "auto/GEO.ff"

      call kugetc(slnam,l)
      call kugeti(lay)
      call uctoh(slnam,slnamh,4,4)

c------------------------------------------------------ Define colors
c      if (first) then
         kwkid=1           ! Red Green Blue

c         call iscr(kwkid,31, 0.5, 0.8, 0.0)
c         call iscr(kwkid,32, 0.0, 0.8, 0.5)
c         call iscr(kwkid,33, 1.0, 0.0, 0.0)
c         call iscr(kwkid,34, 0.8, 0.0, 0.2)
c         call iscr(kwkid,35, 0.2, 0.0, 0.8)
c         call iscr(kwkid,36, 0.0, 0.0, 1.0)
                           
c         call iscr(kwkid,37, 0.4, 0.6, 0.0)
c         call iscr(kwkid,38, 0.0, 0.6, 0.4)
c         call iscr(kwkid,39, 0.7, 0.0, 0.0)
c         call iscr(kwkid,40, 0.5, 0.0, 0.2)
c         call iscr(kwkid,41, 0.3, 0.0, 0.6)
c         call iscr(kwkid,42, 0.0, 0.0, 0.7)

c---------------------------------------------------------- 5 mm
         call iscr(kwkid,31, 0.95, 0.95, 0.0 ) !  1
         call iscr(kwkid,32, 0.  , 0.85, 0.85) !  2
                          
         call iscr(kwkid,33, 0.9 , 0.25, 0.5 ) !  3
         call iscr(kwkid,34, 1.0 , 0.0 , 0.0 ) !  4
                          
         call iscr(kwkid,35, 0.4 , 0.8 , 0.6 ) !  5
         call iscr(kwkid,36, 0.0 , 1.0 , 0.0 ) !  6
c---------------------------------------------------------- 10 mm
         call iscr(kwkid,37, 0.62, 0.47, 0.8 ) !  7
         call iscr(kwkid,38, 0.7 , 0.15, 0.7 ) !  8
                          
         call iscr(kwkid,39, 0.8 , 0.7 , 0.25) ! 10
         call iscr(kwkid,40, 0.75, 0.5 , 0.3 ) !  9
                          
         call iscr(kwkid,41, 0.50, 0.35, 0.55) ! 11
         call iscr(kwkid,42, 0.6 , 0.6 , 0.4 ) ! 12
c----------------------------------------------------------

c         first = .false.
c      end if

c------------------------------------------------------ Find superlayer
      if (slnam(:3).eq.'ALL') then
         pl1 = 1
         pl2 = ngede()
         goto 10
      end if

      do isl=1,ngesl()
         if (slnamh.eq.iq(hqgesl_name(isl))) then
            pl1 = igesl_fpl(isl)
            pl2 = pl1 + igesl_npl(isl) - 1
            goto 10
         end if
      end do

      write (*,*) 'Superlayer ',slnam,' is not found!'
      return
 
 10   continue

c------------------------------------------------------ Loop on planes
      call iselnt(51)         ! switch to Prism NT
      do pl=pl1,pl2
         if (igede_cmp(pl).eq.2
     @       .and. (lay.eq.0 .or. igede_lay(pl).eq.lay)) call dilab1(pl)
      end do

c-----------------------------------------------------
 
*     **** header text
      if (lheaderzg.and.index(choptzg,'H').eq.0
     +     .and.index(choptzg,'A').eq.0) call dihead()
 
*     **** complete frame
      if (lframezg.and.index(choptzg,'A').eq.0) call diedge(choptzg)
c-----------------------------------------------------
 
      call colsec
      call iselnt(51)         ! switch to Prism NT
      call iuwk(0,1)
      return
      end

c=======================================================================
      subroutine colsec
      implicit none

      integer kwkid,isec
      real x(2),y(2),win_x1,win_x2,win_y1,win_y2
      character*50 c

      integer lenocc

      call pigrst
      win_x1 = 0.
      win_x2 = 20.
      win_y1 = 0.
      win_y2 = 20.
      
      kwkid=1

      call igset('PLCI',1.)     ! black
      call igset('LTYP',1.)     ! line type
      call igset('LWID',1.)     ! line width
      
      call igset('FAIS',1.)     ! solid
      call igset('FASI',1.)
      call igset('BORD',1.)     ! draw borders
      call igset('TXFP',-62.)   ! text font
      call igset('TXAL',23.)    ! alignment: center mid

      call igset('CHHE', 0.5)  ! Character height
      call itx(0.5*(win_x1+win_x2),
     @         win_y2 - 0.025*(win_y2-win_y1),
     @         'Colors of sectors')
      call igset('CHHE', 0.5)  ! Character height

      do isec=1,12
         y(2) = -0.05*(win_y2-win_y1) + win_y2
         y(1) = y(2) -0.05*(win_y2-win_y1)
         x(1) = real(isec-1.)/12. * (win_x2-win_x1) + win_x1
         x(2) = real(isec   )/12. * (win_x2-win_x1) + win_x1
         call igset('FACI', real(isec+30)) ! fill color
         call igbox (x(1), x(2), y(1), y(2)) ! box
         write (c,'(i2)') isec
         call itx(0.5*(x(1)+x(2)),0.5*(y(1)+y(2)),c(:lenocc(c)))
      end do

c--------------------------------------------------------------
      return
      end

c=======================================================================
      subroutine dilab1(pl)
*********************************************************
* (This routine is made from diplab.F by Rainer Mankel)
*********************************************************
      implicit none
#include "arte/Arte.fi"
#include "pris/zgraf.fi"
#include "auto/GEO.fi"

      character*20 chopt
      real xxx(5), yyy(5), wc(3,4), tg, xmin, xmax, ymin, ymax
      real x1,x2,x3,x4,y1,y2,y3,y4
      integer ii, pl, isl, cmp, sect, kwkid
      logical llist

#include "arte/Arte.ff"
#include "auto/GEO.ff"

      chopt = ' '

      llist   = index(chopt,'L').gt.0
      isl = ogede_gesl(pl)
      if (isl.le.0) print *,' () diplab: pl,isl=',pl,isl
      cmp = igesl_cmp(isl)

      if (cmp.eq.5) then        ! no RICH here
**         print *,' diplab: unsupported cmp=', cmp
         go to 999
      endif

*     **** choose borders
      if (lsenszg) then
         xmin = fgede_sxmn(pl)
         xmax = fgede_sxmx(pl)
         ymin = fgede_symn(pl)
         ymax = fgede_symx(pl)
      else
         xmin = fgede_xmin(pl)
         xmax = fgede_xmax(pl)
         ymin = fgede_ymin(pl)
         ymax = fgede_ymax(pl)
      endif

      if (llist) then
       print *,' diplab: display plane ',pl,
     +        ' cmp= ',cmp,
     +        ' isl=',isl
       print *,'            borders xmin/mx,ymin/mx=',
     +        xmin,xmax,ymin,ymax
      endif

*     **** tan(stereo angle)
      if (fgede_cos(pl).ne.0.) then
       tg = fgede_sin(pl) / fgede_cos(pl)
      else
       tg = fgede_sin(pl) / 0.00001
      endif

      if (.not.lstereozg) then
*        **** bypass stereo planes
         if (cmp.ne.1) then
            if (abs(fgede_sin(pl)).gt.0.05
     +           .or.abs(fgede_rot(2,pl)).gt.0.05)
     +           go to 999
         endif
      endif

*     **** corners of plane (using world coordinates)
      call igset('PLCI',coplbzg)
      call isln(15)

      if (igede_shp(pl).le. 2 .or. igede_shp(pl).eq.10
     +.or.igede_shp(pl).eq.42 .or. igede_shp(pl).eq.34) then
*        **** basic shape
         wc(1,1) = xmin
         wc(2,1) = ymin
         wc(3,1) = fgede_zmin(pl)

         wc(1,2) = xmax
         wc(2,2) = ymin
         wc(3,2) = fgede_zmin(pl)

         wc(1,3) = xmax
         wc(2,3) = ymax
         wc(3,3) = fgede_zmin(pl)

         wc(1,4) = xmin
         wc(2,4) = ymax
         wc(3,4) = fgede_zmin(pl)

*        **** shear shape for epiped
         if (igede_shp(pl).eq.10) then
            do ii=1,4
               wc(1,ii) = wc(1,ii) + tg * wc(2,ii)
            enddo
         endif
      else
         print *,' () diplab: unsupported shape, shp, pl=',
     +        igede_shp(pl), pl
         go to 999
      endif

      if (fgede_rot(1,pl).ne.1.) then
*        **** additional rotation
         do ii=1,4
*           **** use 2D rotation matrix
            call diroxy(wc(1,ii),fgede_rot(1,pl),-fgede_rot(2,pl))
         enddo
      endif

*     **** projection
      do ii=1,4
         call dipro(wc(1,ii),xxx(ii),yyy(ii))
      enddo

*     **** close the parallelogram
      xxx(5) = xxx(1)
      yyy(5) = yyy(1)


      if (lsclipzg) then
         x1 = xxx(1)
         x2 = xxx(2)
         x3 = xxx(3)
         x4 = xxx(4)
         y1 = yyy(1)
         y2 = yyy(2)
         y3 = yyy(3)
         y4 = yyy(4)
         if (amax1(x1,x2,x3,x4).lt.xminzg) go to 998
         if (amin1(x1,x2,x3,x4).gt.xmaxzg) go to 998
         if (amax1(y1,y2,y3,y4).lt.yminzg) go to 998
         if (amin1(y1,y2,y3,y4).gt.ymaxzg) go to 998
      endif

*     **** draw plane
      call isplci(int(coplbzg))
      call igsg(1)
      call isln(1)

*     **** draw plane volume if opaque option active
      if (lopaquezg) then
         call igset('PLCI',coplvzg)

         sect = igede_sec(pl)
         if (sect.ne.0) then
            call igset('FACI',real(sect+30))

c---------------------------------------------- Choose method: fill or hatch
            call igset('FAIS',1.) ! fill

c            call igset('FAIS',3.) ! fill hatched
c            call igset('FASI',344.) ! hatch style (PAW, page 307)

         else
            call igset('FAIS',0.) ! not fill
         end if

         call igset('BORD',0.)
         call ifa(5,xxx,yyy)
      endif
*     **** draw plane border
      call igset('PLCI',coplbzg)
      call igset('FAIS',0.)
      call igset('LWID',1.)
      call ipl(5,xxx,yyy)

 998  call isfaci(0)
      call isfais(0)

**    call iuwk(0,1)
**    call igsa(1)

 999  end
