// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#include <iostream.h>
#include <math.h>
#include "arte/arte.hh"
#include "rang/RadPhoton.hh"
#include "rang/zfpar.hh"
#include "rang/utfeld.hh"
#include "rang/RadEl.hh"
#include "rang/ParticleType.hh"

rangerRadPhoton::rangerRadPhoton(){
  photEnergy = 0;
  photError = 0;
}


rangerRadPhoton::rangerRadPhoton(const float energy,const float eError,
				 const float zRad,rangerNode* n) 
  : rangerThin(n->getState().fitMode()) {
  photEnergy = energy;
  photError = eError;
  z = zRad;
  state->linExtrapVec( n->getState(), z);
}


void rangerRadPhoton::processNoise(rangerParticleType ) {

  state->applyRadPhoton(photEnergy,photError);
}


void rangerRadPhoton::predProcessNoise(rangerParticleType ) {

  predictedState->applyRadPhoton(photEnergy,photError);

}
