*-- Author :    Rainer Mankel   21/09/95

      subroutine dmdom97()

*     **** setup zdomain
      implicit none

#include "rang/zdomain.fi"
#include "rang/zdomdir.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
      integer max_domain
      parameter (max_domain=6)
      integer scope_domain(max_domain), domain, iisl, sl, pl, layer,
     +        sector, method, ii, jj, lastwin_sect(max_sector_dm), n_sum
      real z_sum

      logical active_domain(max_domain)
      character*4 c_domain(3,max_domain), csl
      data ((c_domain(ii,jj),ii=1,3), scope_domain(jj),
     +                          active_domain(jj),jj=1,max_domain)/
     +    'SI01', '    ', '    ', 1, .true.,
     +    'SI02', '    ', '    ', 1, .true.,
     +    'SI03', '    ', '    ', 1, .true.,
     +    'PC01', '    ', '    ', 3, .true.,
     +    'PC02', '    ', '    ', 3, .true.,
     +    'PC03', '    ', '    ', 3, .true./

      data lastwin_sect /max_sector_dm * 0/
      save c_domain, scope_domain, lastwin_sect

#include "arte/Arte.ff"
#include "auto/GEO.ff"

      do domain=1,max_domain   ! loop over domains
       if (active_domain(domain)) then
        do iisl=1,min(3,maxsl_dm)
         if (c_domain(iisl,domain).ne.'    ') then
          nwin_dm(domain) = 0
          win1_dm(domain) = 0
          pc_dm(domain) = 0
          do 10 sl=1,iq(jgesl+2)   ! search for matching SL
           write(csl,'(a4)') hgesl_name(sl)
           if (csl.eq.c_domain(iisl,domain)) then
            domsl_dm(iisl,domain) = sl
            scope_dm(domain) = scope_domain(domain)
            go to 11
           endif
 10       continue
          print *,' () dmdom97: match not found for ',
     +                                      c_domain(iisl,domain)
          domsl_dm(iisl,domain) = 0
 11       continue
         else
          domsl_dm(iisl,domain) = 0
         endif
        enddo ! iisl
       endif ! active_domain
      enddo ! domain
      n_dm = max_domain
      print *,' dmdom97: #domains created=', n_dm

*     **** set up domain windows
      n_dw = 0
      do domain=1,max_domain   ! loop over domains
       z_sum = 0.
       n_sum = 0.
       do sector=1,max_sector_dm
        do iisl=1,maxsl_dm
         sl = domsl_dm(iisl,domain)
         if (sl.gt.0.and.sl.ge.min_sl_dm.and.sl.le.max_sl_dm) then
          layer = 1
          if (igesl_cmp(sl).eq.1) then
           method = 1  ! exist no 0-deg for Si
          else
           method = 2  ! take 0-deg
          endif
          pl = plane_matrix_dm(layer,method,sector,sl)
          if (pl.gt.0) then
           if (n_dw.lt.maxwin_dw) then   ! new window
            n_dw = n_dw + 1
            nwin_dm(domain) = nwin_dm(domain) + 1
            if (nwin_dm(domain).eq.1) win1_dm(domain) = n_dw
            domain_dw(n_dw) = domain
            plshad_dw(n_dw) = pl
            secshad_dw(n_dw) = sector
            if (lastwin_sect(sector).gt.0) then
             prvwin_dw(n_dw) = lastwin_sect(sector)
             nxtwin_dw(lastwin_sect(sector)) = n_dw
            else
             prvwin_dw(n_dw) = 0
            endif
            nxtwin_dw(n_dw) = 0
            lastwin_sect(sector) = n_dw  ! memorize for nxt dom
            do ii=1,3
             nlayer_dw(ii,n_dw) = 0
             layer1_dw(ii,n_dw) = 0
            enddo
            xmin_dw(n_dw) = fgede_sxmn(pl)
            xmax_dw(n_dw) = fgede_sxmx(pl)
            ymin_dw(n_dw) = fgede_symn(pl)
            ymax_dw(n_dw) = fgede_symx(pl)
            zmin_dw(n_dw) = fgede_zmin(pl)
            zmax_dw(n_dw) = fgede_zmax(pl)
           else
            print *,' () dmdom97: overflowing n_dw=', n_dw
           endif ! n_dw
          endif ! pl
         endif ! good sl
        enddo ! iisl
       enddo ! sector
       if (n_sum.ge.1) then
        z_dm(domain) = z_sum / n_sum  ! store reference z for domain
       else
        print *,' () dmdom: no window in domain=',domain
        z_dm(domain) = 1000.
       endif
      enddo ! domain
      print *,' dmdom97: # domain windows created=', n_dw

      end


