// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerGeom
// static class with derived geometry information

#ifndef rangerGeom_HH
#define rangerGeom_HH

#include "arte/arte.hh"
#include "rang/Volume.hh"
#include <vector.h>

class rangerGeom {

public:
  static void update();           // initialize or update geometry table
  static void condUpdate();       // initialize or update geometry table
                                  //  only if number of planes has changed 
  static void reset();            // clear geometry table
  static void build();            // build geometry table
  static void gsort();             // sort geometry table
//   static inline rangerVolume* vol
//   (ArtePointer<GEDE> gede){ return PGede[gede.index()-1];}  // lookup 
//   static inline rangerVolume* vol
//   (ArtePointer<GWAL> gwal){ return PGwal[gwal.index()-1];}  // lookup 
  static inline rangerVolume* vol
  (ArtePointer<GEDE> gede){ return *vGede[gede.index()-1];}  // lookup 
  static inline rangerVolume* vol
  (ArtePointer<GWAL> gwal){ return *vGwal[gwal.index()-1];}  // lookup 
  static inline vector<rangerVolume*>::iterator volN(int plane)
    { return ((plane>0)? vGede[plane-1] : vGwal[-plane-1]); }
  static inline int vsn(vector<rangerVolume*>::iterator v)
    { return (v-volumes.begin()); } // volume sequence number

private:
  static int nVolume;           // number of rangerVolumes
  //static rangerVolume** volume; // array of pointers to rangerVolumes
  //static rangerVolume** PGede;
  //static rangerVolume** PGwal;
  //static rangerVolume* firstVolume;  // pointer to first volume in z
  //static rangerVolume* lastVolume;   // pointer to last  volume in z
  static vector<rangerVolume*> volumes; // vector of pointers to rangerVolumes
  static vector<vector<rangerVolume*>::iterator> vGede;
  static vector<vector<rangerVolume*>::iterator> vGwal;
};

#endif
