// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerThinWall
// class for thin multiple scattering object based on Gwal object

#ifndef rangerThinWall_HH
#define rangerThinWall_HH

#include "arte/arte.hh"
#include "rang/Node.hh"
#include "rang/Thin.hh"
#include "rang/Volume.hh"


class rangerThinWall : public rangerThin {

public:

  rangerThinWall();
  rangerThinWall(const ArtePointer<GWAL>& gw,rangerNode* n);
  rangerThinWall(const ArtePointer<GWAL>& gw,rangerNode* n,const float path);
  virtual ~rangerThinWall(){};   // virtual destructor
  
  inline float ms() const {return sPath*vol->ms();}
  inline float msPlain() const { return sPath*gwal->ms; }
  inline float dz(){return (gwal->zmax - gwal->zmin);}
  inline int plane(){return -gwal.index();}

protected:

private:
  ArtePointer<GWAL> gwal;
  rangerVolume* vol;
  float sPath;                 // path of track in volume, scaled to |zmax-zmin|
};

#endif
