// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// rgxprofi_
// Fortra-callable setter which fills the horizontal projection candidate 
// information for a specific domain.

#include "rang/Domain.hh"
#include "rang/DomWin.hh"
#include "rang/DomObj.hh"
#include "rang/XPro.hh"
#include "rang/XWin.hh"

extern rangerDomObj* rangerDO;   // global DO pointer

extern "C" {
  void rgxprofi_(rangerDomain*& dom,  // Domain to which information applies
		 rangerDomWin*& win,  // domain window passed by candidate
		 float& z,            // reference z for following information
		 double& x,           // x position at reference z
		 double& tx) {        // x slope at reference z
                                      // (all parameters are input)
    rangerDO->xpro()->xWinFill(dom,win,z,x,tx);
  }
}
