// ********************************************************************
//
//  Routine:      rc99Aevnt
//  Author:       T.Oest/D.Samtleben
//
//  Description:  event reconstruction
//
//  Modification:
//    -- matching added                         03/06/99 T.Oest
//    -- vertexing added                        06/09/99 T.Oest
//    -- particle ID added                      16/09/99 T.Oest
//    -- event classification added,
//       select decay candidates                29/10/99 T.Oest
//    -- track points RPNT filled               07/01/00 T.Oest
//    -- fill EVHI bank                         09/02/00 T.Oest
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "reco/rc99Areco.hh"

static int firstcall = 1;

int  rc99Arefit();
int  rc99SelectTracks();
int  rcSelectDecays();
int  rcSetTrackPoints();
int  rcClassify();
void rc99Avertex();
void rcfillEVHI();


//*****************************************************************
// function   no action for MC
//*****************************************************************

void rc99Aevnt() {

//==================================================================
// 1. initialization, return for MC
//==================================================================

  ArtePointer<EVHD> header(1);

  if (ArteTable<MTRA>::begin() != ArteTable<MTRA>::end()){
     if (header->exp > 0 )         header->exp = -1;
  };

     if (firstcall == 1 ) {
      rc99Ainit();
      firstcall = 0;
     };

//==================================================================
// 2. stand alone reconstruction
//==================================================================

   int rcStandAloneFlag = 0;
   rcStandAloneFlag     = rc99AStandAlone();
  
//==================================================================
// 3. matching, track selection
//==================================================================

   int MatchingFlag = rc99Match();
   int RTRAFlag     = rc99SelectTracks();
  
//==================================================================
// 4. refit of tracks, fill RPNT bank
//==================================================================

   int refit        = 0;
   refit            = rc99Arefit();
   int RPNTFlag     = rcSetTrackPoints();

//==================================================================
// 5. Particle ID
//==================================================================

   int ParticleID = 0;
   ParticleID     = rc99AParticleID();

//==================================================================
// 6. vertexing
//==================================================================

   rc99Avertex();
  
//==================================================================
// 7. reconstruction of decays
//==================================================================

   int SelectDecays = rcSelectDecays();

//==================================================================
// 8. set event classification flag
//==================================================================

   rcClassify();
  
//==================================================================
// 9. fill EVHI bank
//==================================================================

   rcfillEVHI();

}
