// ********************************************************************
//
//  Routine:      rc99Avertex
//  Author:       T.Oest
//
//  Description:  main vertex reconstruction
//
//  Modification:
//   -- vertex reconstruction only together with matching
//                                                      16/09/99 T.Oest
//   -- also called if new tracks are selected          01/12/99 T.Oest
//   -- K0S included, steering included
//
// ********************************************************************

#include <algo.h>
#include <arte/arte.hh>
#include <arte/artefunc.h>
#include "reco/rcflags.hh"

extern "C" {
 void rc99avtrec_(const int& flag);
 void vtpsto_(const int& flag);
 void v0k0s_();
};


//*****************************************************************
// function  
//*****************************************************************

void rc99Avertex(){

//==================================================================
// main vertexing
//==================================================================

  if (rcMainVertex == 1){
   int flag;
   rc99avtrec_(flag);
   vtpsto_(flag);
  };

//==================================================================
// K0s vertexing
//==================================================================

  if (rcK0SVertex == 1)  v0k0s_();

};
