// ********************************************************************
//
//  Routine:      rc99SelectTracks
//  Author:       T.Oest
//
//  Description:  select tracks from matched segments
//
//  Modification:
//  -- remove Rxxx banks before track selection        01/12/99 T.Oest
//  -- 2000 track selection added                      10/02/00 T.Oest
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "reco/rc99Areco.hh"
#include "reco/rcflags.hh"

void rc99inventRTRA();
void rcinventRTRA();

//*****************************************************************
// function  
//*****************************************************************

int rc99SelectTracks() {

  int flag = 0;

//==================================================================
// remove tracks and vertices
//==================================================================

  if (rcSelectTracksStatus == 1) {
     if (ArteTable<RTRA>::size() !=0) ArteTable<RTRA>::clear();
     if (ArteTable<RVER>::size() !=0) ArteTable<RVER>::clear();
     if (ArteTable<RREL>::size() !=0) ArteTable<RREL>::clear();
     if (ArteTable<RPNT>::size() !=0) ArteTable<RPNT>::clear();
  };

//==================================================================
// select VDS/ECAL tracks (+RICH)
//==================================================================

  if (rcSelectTracksStatus == 1) rc99inventRTRA();

//==================================================================
// select VDS/OTR tracks
//==================================================================

  if (rcSelectTracksStatus == 2) rcinventRTRA();

//==================================================================
  return flag;

};

