// ********************************************************************
//
//  Routine:      rcDQinit
//  Author:       T.Oest
//
//  Description:  initialization of DQ histograms
//
//  Modification:
//
// ********************************************************************
 
// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>
#include "arte/RSEG_cmp.hh"

#include "arte/arte.hh"
#include "rhp.h" 
#include "dq/DQ.h"


//******************************************************************
// function
//******************************************************************

void rcDQinit() {

//-----------------------------------------------------------------
//  error flag
//-----------------------------------------------------------------

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 1), 
             "RECO: error flag ", 2, -0.5, 1.5 );

//-----------------------------------------------------------------
//  Jpsi histograms
//-----------------------------------------------------------------

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 100), 
             "RECO: J/psi-> ee candidates ", 60, 2, 5 );

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 101), 
             "RECO: J/psi-> ee candidates, hard cuts ", 60, 2, 5 );

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 102), 
             "RECO: J/psi-> ee candidates, hard cuts, using E(ecal) ", 60, 2, 5 );

  rhp_hbook2( DQ_ID(COMP_RECO,LVL_REC, 103), 
             "RECO: tx vs ty for Jpsi candidates ", 100, -0.2, 0.2,
                                               100, -0.2, 0.2);

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 104), 
             "RECO: E over p ", 100, -2, 2 );

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 105),
             "RECO: E over p, pure Jpsi sample ", 100, -2, 2 );

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 106), 
             "RECO: Jpsi vertex z, pure sample ", 100, -15, 10 );


//-----------------------------------------------------------------
//  main vertices
//-----------------------------------------------------------------

  rhp_hbook2( DQ_ID(COMP_RECO,LVL_REC, 201), 
             "RECO: main vertices II station ", 100, -1, 1, 100, -1, 1);
  rhp_hbook2( DQ_ID(COMP_RECO,LVL_REC, 202), 
             "RECO: main vertices I  station ", 100, -1, 1, 100, -1, 1);
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 203), 
             "RECO: vertices per wire ", 8, 0.5, 8.5 );
  rhp_hbook2( DQ_ID(COMP_RECO,LVL_REC, 204), 
             "RECO: main vertices zx ", 100, -10, 5, 100, -1, 1);
  rhp_hbook2( DQ_ID(COMP_RECO,LVL_REC, 205), 
             "RECO: main vertices zy ", 100, -10, 5, 100, -1, 1);

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 210), "RECO:  x wire  Ia ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 211), "RECO:  x wire  Ib ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 212), "RECO: dx wire  Ii ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 213), "RECO: dx wire  Io ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 214), "RECO:  x wire IIa ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 215), "RECO:  x wire IIb ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 216), "RECO: dx wire IIi ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 217), "RECO: dx wire IIo ", 100, -0.5, 0.5 );

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 220), "RECO: dy wire  Ia ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 221), "RECO: dy wire  Ib ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 222), "RECO:  y wire  Ii ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 223), "RECO:  y wire  Io ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 224), "RECO: dy wire IIa ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 225), "RECO: dy wire IIb ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 226), "RECO:  y wire IIi ", 100, -0.5, 0.5 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 227), "RECO:  y wire IIo ", 100, -0.5, 0.5 );

  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 230), "RECO: dz wire  Ia ", 100, -1, 1 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 231), "RECO: dz wire  Ib ", 100, -1, 1 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 232), "RECO: dz wire  Ii ", 100, -1, 1 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 233), "RECO: dz wire  Io ", 100, -1, 1 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 234), "RECO: dz wire IIa ", 100, -1, 1 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 235), "RECO: dz wire IIb ", 100, -1, 1 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 236), "RECO: dz wire IIi ", 100, -1, 1 );
  rhp_hbook1( DQ_ID(COMP_RECO,LVL_REC, 237), "RECO: dz wire IIo ", 100, -1, 1 );

};



