// ********************************************************************
//
//  Routine:      rcDQvertex
//  Author:       T.Oest
//
//  Description:  fill vertex DQ histograms
//
//  Modification:
//
// ********************************************************************

// includes
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <algo.h>
#include "arte/RSEG_cmp.hh"

#include "arte/arte.hh"
#include "rhp.h" 
#include "dq/DQ.h"

//*****************************************************************
// function
//*****************************************************************

void rcDQvertex(){

//-----------------------------------------------------------------
//  active wires
//-----------------------------------------------------------------
    int wireFlag[8];
    int i = 0;

    for( ArteTable<GTAR>::iterator gtar = ArteTable<GTAR>::begin();
         gtar != ArteTable<GTAR>::end();
         ++gtar ) {
      if ( ((*gtar)->x * (*gtar)->x +(*gtar)->y * (*gtar)->y ) < 1){
       wireFlag[i] = 1;
      } else {
       wireFlag[i] = 0;
      };
      i++;
    };

//-----------------------------------------------------------------
//   main vertices
//-----------------------------------------------------------------

   for( ArteTable<RVER>::iterator rver = ArteTable<RVER>::begin();
        rver != ArteTable<RVER>::end(); ++rver ) {

    if ((*rver)->btra == 0 ){

//-----------------------------------------------------------------
//   closest target wire
//-----------------------------------------------------------------

    int igtar = 0;
    i = 0;
    float diff = 0.0;
    float dx, dy, dz;
    float dzmin;
    ArtePointer<GTAR> Vgtar;

    for( ArteTable<GTAR>::iterator gtar = ArteTable<GTAR>::begin();
         gtar != ArteTable<GTAR>::end();
         ++gtar ) {
      i++;
      if (wireFlag[i-1] ==1) {

      dx = ((*gtar)->x - (*rver)->xv)/(*gtar)->dx;
      dy = ((*gtar)->y - (*rver)->yv)/(*gtar)->dy;
      dz =  (*gtar)->z - (*rver)->zv;

      if ( fabs(dz) < 1. && 
           (sqrt(dx*dx+dy*dy) < diff || igtar == 0)) {

        diff  = sqrt(dx*dx+dy*dy);
        Vgtar = *gtar;
        igtar = i;
      };
      };
    };

//-----------------------------------------------------------------
//  
//-----------------------------------------------------------------

     rhp_hfill(DQ_ID(COMP_RECO, LVL_REC, 204) ,(*rver)->zv, (*rver)->xv ,1);
     rhp_hfill(DQ_ID(COMP_RECO, LVL_REC, 205) ,(*rver)->zv, (*rver)->yv ,1);


     if ( igtar != 0){


      if ( Vgtar->z > -3.0 ){
          rhp_hfill(DQ_ID(COMP_RECO, LVL_REC, 201) ,(*rver)->xv, (*rver)->yv ,1);
      } else { 
          rhp_hfill(DQ_ID(COMP_RECO, LVL_REC, 202) ,(*rver)->xv, (*rver)->yv ,1);
      };


     if (diff < 100)
     rhp_hf1( DQ_ID(COMP_RECO, LVL_REC, 203) , float(igtar) , 1 );


     if ( igtar == 1 || igtar == 2 || igtar == 5 || igtar == 6){
      dx = (*rver)->xv;
      dy = (*rver)->yv - Vgtar->y;
     } else {
      dx = (*rver)->xv - Vgtar->x;
      dy = (*rver)->yv;
     };

     dz = (*rver)->zv - Vgtar->z;

     rhp_hf1( DQ_ID(COMP_RECO, LVL_REC, (209+igtar)) , dx, 1 );
     rhp_hf1( DQ_ID(COMP_RECO, LVL_REC, (219+igtar)) , dy, 1 );
     rhp_hf1( DQ_ID(COMP_RECO, LVL_REC, (229+igtar)) , dz, 1 );

    };
//-----------------------------------------------------------------
//  
//-----------------------------------------------------------------

};
};
};

