// 
//  Author:  Rainer Mankel                     Created:  02-Mar-99
//           Humboldt University Berlin        Modified: 13-Jun-99
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// includes
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"
#include "reco/recoOptions.hh"

//
// function
//

extern "C" {
}
int SvdInit();

extern recoOptions RecoOpt;

extern "C" {
  void rcinit_()
  {

    static int init = 0;

    if (! init) {
      arteMsg << "HERA-B reconstruction version 1.03/00";
      arteMsg.warn();

      SvdInit();

      // set default activations for algorithms
      RecoOpt.SetInActiveAlg("HOLMES");
      RecoOpt.SetInActiveAlg("CATS");
      RecoOpt.SetInActiveAlg("RIRE");
      RecoOpt.SetInActiveAlg("RITER");
      RecoOpt.SetInActiveAlg("MURECA");
      RecoOpt.SetInActiveAlg("MURECB");
      RecoOpt.SetInActiveAlg("VERTEX");

      init = 1;
    }
  }
}

// Versions history

// 1.03/00 - storage of neutrals added, bremsstrahlung correction foreseen.
//           Matching VDS/main tracker added.

// 1.02/03 - Jpsi vertex search removed in rcvert()

// 1.02/02 - track-based muon reco added

// 1.02/01 - call to RITER and VDS pattern recognition (cats,holmes)
//           added

// 1.02/00 - RICH reconstruction added. Reconstruction options.

// 1.01/00 - matching between tracks and reconstructed ECAL 
//           clusters added (using matchRsegCare). 
//    	     A first simple electron identification (rcelid.C)
//           was added & included in rcevnt. rcinit.C added
//           for module initialization.  (2-Mar-99)

// 1.00/00 - first version of default reconstruction, includes
//           ideal VDS reconstruction, main tracker reconstruction,
//           ideal matching and full refit.
