//--*-C++-*--
#ifndef __RingSearchARTE_H__
#define __RingSearchARTE_H__

#include "rise/ring.h"
#include "rise/RingSearchDB.h"
#include <vector.h>

extern "C" {
  void rcrings_(float r1=30,float r2=53,float dr=-1,int t=5);
  void rcringsdb_();
  void rcringsid_(ArtePointer<RTRA> t);
  void rcringsclean_();
	   }
float* ringid(ArtePointer<RTRA> t);
float* ringid(float pf, float radius);

///////////////////// RingSearchARTE ////////////////////////////////////

/// ARTE interface to stand-alone ringsearch program
class RingSearchARTE : public RingSearchDB {
private:
  // -- hits
  Hits            h;
  void            makeHitMap();

  // -- dualspace
  DualSpace d;

  // -- track/ring
  void            SetSeed();
  void            Choose();
  void            FillRSEG();
  void            FillRTRA(ArtePointer<RTRA> t, ArtePointer<RSEG> rich);
  int             n_mass;
  float           iR2P2sigma2[5];
  float           R2P2rad2[5];
  float           lr[5];
  vector<float>   radius_list;
  void            makeRadiusList(float r1, float r2, float dr);


public:
  RingSearchARTE();
  void   getrings(float r1,float r2,float dr,int t);
  void   getrings();
  int    swim(const double *source,double *dest,const double zout);
  int    R2P2likelihood(ArtePointer<RTRA> t);
  int    R2P2likelihood(float radius);
  void   makeR2P2lines();

  // -- access to reco data
  inline int    numrings()    const { return d.numring();  }
  inline Ring   &getRing(int i)     { return d.getRing(i); }
  inline int    imtra(int i)  const { return d.mctrack(i); }
  inline float* GetLr()             { return &lr[0]; }
};


extern RingSearchARTE *RICH_Search;

#endif
