//--*-C++-*--
#include "RICHEventMC.h"
#include "CLHEP/Hist/HBookTuple.h"

#ifdef RISE_ROOT

#include "TFile.h"
#include "TTree.h"
#include "TBranch.h"
#include "TH1.h"

/** Compares RingSearch reconstruction parameters with MC values. 
Usage: 
- define ROOTFILE in you kumac (directory where to save root file)
- and in usevnt call, AFTER ring reconstruction:
     RICH_Efficiency = new RingSearchEfficiency;
     RICH_Efficiency->fillNtuple;
- in usstop:
     delete RICH_Efficiency;
*/
class RingSearchEfficiency {

 private:
  typedef struct {
    float mc_tx, mc_ty, mc_rad;
    float rc_tx, rc_ty, rc_rad;
    float mc_x[3];
    float mc_Tx, mc_Ty;
    float mc_p;
    float mc_pho, rc_pho;
    float rc_background;
    float rc_f;
    float mc_type, mc_moth;
    float multi;
    float mc_x0, mc_y0, mc_z0;
    float Rb, S;
    int   good;
    int   assigned;
  } Ring;
  Ring ring;

  typedef struct {
    float rc_tx, rc_ty, rc_rad;
    float mc_p, rc_p;
    float lre, lrmu, lrpi, lrk, lrp;
    float sn, Rb, S;
    int   type, mother; 
    int   hsi, hin, hou, hri;
  } RingId;
  RingId ringid;

  TFile *ring_file;
  TTree *ring_tree;
  TH1F  *dphi, *raw_dphi;
  TH1F  *dlam, *raw_dlam;
  TH1F  *pho_assign;
  TTree *id_tree;

  void MultiPhoton();

 public:
  RingSearchEfficiency();
  ~RingSearchEfficiency();
  void fillNtuple();
  void fillNtupleID();
};

extern RingSearchEfficiency *RICH_Efficiency;

#endif
