#ifndef _L3_IMPACTBASE_HH_
#define _L3_IMPACTBASE_HH_
// *****************************************************************************
//
// source:    L3_ImpactBase.hh
//
// type:      include file
//
// created:   06 Dec 1999
//
// authors:   Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// changes:
//
// *****************************************************************************
#include <iostream.h>

class L3_ImpactBase {
public:
  inline L3_ImpactBase();
  inline L3_ImpactBase(const L3_ImpactBase& a){ *this = a; }
  inline L3_ImpactBase(float mag,float variance);
  inline float mag() const;      //size of impact parameter
  inline float variance() const; //variance of impact parameter
  inline float sign() const; //sign of 1d impact parameter, always TRACK-TARGET
  inline L3_ImpactBase& operator=(const L3_ImpactBase &);
protected:
  float t_mag,t_variance;
  float t_sign;
};

ostream& operator<<(ostream&,const L3_ImpactBase&);

#include "L3_ImpactBase.icc"
#endif
