#ifndef _L3_TRIGGER_HH_
#define _L3_TRIGGER_HH_
// *****************************************************************************
//
// source:    L3_Trigger.hh
//
// type:      include file
//
// created:   06 Dec 1999
//
// authors:   Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// changes:
//
// *****************************************************************************

#include "L3_Defines.hh"

#include "L3_State.hh"
#include "L3_Event.hh"
#include "L3_Timer.hh"
#ifndef L3_NO_RHP
#include "L3_Monitor.hh"
#endif
#ifdef L3_ARTE_FRAME
#include "L3_Arte.hh"
#endif
#include "L3_DTLT.hh"

class L3_Trigger {
public:
  L3_Trigger();
  L3_Trigger(const L3_Trigger&);
  L3_Trigger& operator = (const L3_Trigger&);

  void init(int argc, char** argv);
  void process();
  void update();
  void stop();
  int trig();
  L3_Event getEvent() const;
  L3_DTLT getDTLT() const;
  const L3_Timer& getTimer() const;
private:  
  L3_State     State;
  L3_Event     Event;
  L3_Timer     Timer;
#ifndef L3_NO_RHP
  L3_Monitor   Monitor;
#endif
#ifdef L3_ARTE_FRAME
  L3_Arte      ArteInterface;
#endif
  L3_DTLT      DTLT_Table;
  void trigger();
  void printEventSummaryHeader() const;
  void printEventSummaryFooter() const;
  //just a simple flag to indicate an accept - just for the 4LT-farm
  int flag;
};

#endif
