*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :  T.Lohse 
c
c------------------------------------------------------------
c
c       subroutine:   VTADD(iv,it,flag)
c
c       input:    iv       =  vertex index      Int
c                 it       =  track  index      Int
c
c       output:   flag   Int  < 0 if fail
c
c       action:   adds track info to vertex iv
c                 (initialization for filter)
c                 refits if track is added to a fitted vertex
c
c------------------------------------------------------------
c
      subroutine  VTADD( iv, it, flag )

      implicit none

      integer iv, it
      integer flag

      integer k, l, ll, momf, ifail

#include "vt/vtdat.fi"


      flag = -1
      if (iv.gt.nvtmax)         goto 999
      if (it.gt.ntrtot)         goto 999
      if (jv(iv,it).ne.0)       goto 999

      l = ntr(iv)
      k = l+1
      if ( k .gt. ntrk )        goto 999
      ll = nv(it) + 1
      if ( ll .gt. nvttrk )     goto 999
      nv(it) = ll
      kv(it,ll) = iv
      jv(iv,it) = ll

      ntr(iv) = ntr(iv)+1
      ktr(iv,ntr(iv)) = it

      xv(1,iv,k)  = xvs(1,iv)
      xv(2,iv,k)  = xvs(2,iv)
      xv(3,iv,k)  = xvs(3,iv)
      qvs(1,iv,k) = p(1,it)
      qvs(2,iv,k) = p(2,it)
      qv(1,iv,k)  = p(1,it)
      qv(2,iv,k)  = p(2,it)
      qvs(3,iv,k) = p(5,it)
      qv(3,iv,k)  = p(5,it)

      dist(iv) = 0
      fitm(iv) = 0

      if ( fit(iv) .ne. 0 ) then
        momf = 0
        if ( fit(iv).eq.2 ) momf = 1
        call VTFIT(iv,momf,ifail)
        if (ifail.ne.0) then
          nv(it) = ll-1
          kv(it,ll) = 0
          jv(iv,it) = 0
          ktr(iv,ntr(iv)) = 0
          ntr(iv) = ntr(iv)-1
          flag = -2
          goto 999
        endif
      endif

      flag     = 0

  999 continue

      return
      end
