*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
c
c------------------------------------------------------------
c
c       subroutine:   VTSMOQ(iv)
c
c       input:    iv       =  vertex index      Int
c
c       output:   none
c
c       action:   smooth momenta for all tracks on vertex iv
c
c------------------------------------------------------------
c
      subroutine VTSMOQ(iv)

      implicit none

      integer iv, momflg

      integer n, i, j, k, m, it, imax, jmax

#include "vt/vtdat.fi"

      double precision 
     1  b13, a33, a34
      double precision 
     1  AGB(5,3), WBG(3,5), BGA(3,3)
      double precision 
     1  pc(5), pcAx(5)

      if (iv.gt.nvtmax)  return
      if ( .not. vtset(iv) )   return

      n  = ntr(iv)
      if ( n.lt.1 )   return
      if ( fit(iv).eq.0 )   return

      if ( fit(iv).eq.2 ) then
        momflg = 1
      else
        momflg = 0
      endif

      if (momflg.eq.0) then
        imax = 4
        jmax = 2
      else
        imax = 5
        jmax = 3
      endif

      b13 = Bk13(iv)

      do  k = 1, n

        a33 = Ak33(iv,k)
        a34 = Ak34(iv,k)

        it = ktr(iv,k)

        do  i = 1, imax
          AGB(i,1) = G(1,i,it)+b13*G(3,i,it)
          AGB(i,2) = G(2,i,it)+b13*G(4,i,it)
        enddo
        if (momflg.ne.0) then
          do  i = 1, 5
            AGB(i,3) = G(i,5,it)
          enddo
        endif
        do  i = 1, jmax
          do  j = 1, imax
            WBG(i,j) = 0.
            do  m = 1, jmax
              WBG(i,j) = WBG(i,j) + W(i,m,iv,k)*AGB(j,m)
            enddo
          enddo
        enddo

        pc(1) = p(1,it)
        pc(2) = p(2,it)
        pc(3) = p(3,it) - b13*a33
        pc(4) = p(4,it) - b13*a34
        if (momflg.ne.0) pc(5) = p(5,it)

        pcAx(1) = pc(1)
        pcAx(2) = pc(2)
        pcAx(3) = pc(3) - xvs(1,iv) - a33*xvs(3,iv)
        pcAx(4) = pc(4) - xvs(2,iv) - a34*xvs(3,iv)
        if (momflg.ne.0) pcAx(5) = pc(5)

        do  i = 1, jmax
          qvs(i,iv,k) = 0.
          do  j = 1, imax
            qvs(i,iv,k) = qvs(i,iv,k) + WBG(i,j)*pcAx(j)
          enddo
        enddo

        BGA(1,1) = G(1,3,it)+b13*G(3,3,it)
        BGA(2,1) = G(2,3,it)+b13*G(3,4,it)
        BGA(1,2) = G(1,4,it)+b13*G(3,4,it)
        BGA(2,2) = G(2,4,it)+b13*G(4,4,it)
        BGA(1,3) = a33*BGA(1,1) + a34*BGA(1,2)
        BGA(2,3) = a33*BGA(2,1) + a34*BGA(2,2)
        if (momflg.ne.0) then
          BGA(3,1) = G(5,3,it)
          BGA(3,2) = G(5,4,it)
          BGA(3,3) = a33*BGA(3,1) + a34*BGA(3,2)
        endif
        do  i = 1, jmax
          do  j = 1, 3
            F(i,j,iv,k) = 0.
            do  m = 1, jmax
              F(i,j,iv,k) = F(i,j,iv,k) + W(i,m,iv,k)*BGA(m,j)
            enddo
          enddo
        enddo

        do  i = 1, jmax
          do  j = 1, 3
            ES(i,j,iv,k) = 0.
            do  m = 1, 3
              ES(i,j,iv,k) = ES(i,j,iv,k) -
     1                    F(i,m,iv,k)*C(m,j,iv,n)
            enddo
          enddo
        enddo
        do  i = 1, jmax
          do  j = i, jmax
            DS(i,j,iv,k) = W(i,j,iv,k)
            do  m = 1, 3
              DS(i,j,iv,k) = DS(i,j,iv,k) -
     1                    ES(i,m,iv,k)*F(j,m,iv,k)
            enddo
            DS(j,i,iv,k) = DS(i,j,iv,k)
          enddo
        enddo

      enddo

      return
      end
